/*
 * Copyright (c) 1982 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)conf.c	6.14 (Berkeley) 2/19/86
 */

#include "param.h"
#include "systm.h"
#include "buf.h"
#include "ioctl.h"
#include "tty.h"
#include "conf.h"

int	nulldev(), nodev(), ttselect(), seltrue();
#define	NU	nulldev		/* noop */
#define	NO	nodev		/* error */

#define	UNUSED_BDEV	{NO, NO, NO, NO, NO, 0 }
#define	UNUSED_CDEV	{NO, NO, NO, NO, NO, NO, NU, 0, NO, NO, 0}


/* -------  BUS INDEPENDENT DEVICES --------- */
int	swstrategy(), swread(), swwrite();
#define	SWAP_BDEV	{NO,NO,swstrategy,NO,0,0}
#define	SWAP_CDEV	{NU,NU,swread,swwrite,NO,NO,NU,0,NO,NO,0}

int	sioopen(),sioclose(),sioread(),siowrite(),sioioctl(),siostop();
struct tty sio_tty[];
#define	SIO_CDEV {sioopen,sioclose,sioread,siowrite,sioioctl,siostop,NU, \
		 sio_tty,ttselect,NO,0}

int	syopen(), syread(), sywrite(), syioctl(), syselect();
#define	SY_CDEV	{syopen,NU,syread,sywrite,syioctl,NU,NU,0,syselect,NO,0}

int 	mmread(), mmwrite(), mmmap();
#define	MEM_CDEV {NU,NU,mmread,mmwrite,NO,NU,NU,0,seltrue,mmmap,0}

int	logopen(),logclose(),logread(),logioctl(),logselect();
#define	LOG_CDEV {logopen,logclose,logread,NO,logioctl,NO,NU,0,logselect,NO,0}

#include "rd.h"
#if NRD > 0 || Nrd > 0
int	rdopen(),rdstrategy(),rdread(),rdwrite(),rdreset(),rddump(),rdsize();
#define	RD_BDEV	{rdopen,NU,rdstrategy,rddump,rdsize,0}
#define	RD_CDEV {rdopen,NU,rdread,rdwrite,NO,NO,rdreset,0,seltrue,NO,0}
#else
#define	RD_BDEV	UNUSED_BDEV
#define	RD_CDEV	UNUSED_CDEV
#endif

#include "ts.h"
#if NTS > 0 || Nts > 0
int	tsopen(),tsclose(),tsstrategy(),tsread(),tswrite(),
	tsioctl(),tsdump(),tsreset();
#define	TS_BDEV	{tsopen,tsclose,tsstrategy,tsdump,0,B_TAPE}
#define	TS_CDEV	{tsopen,tsclose,tsread,tswrite,tsioctl,NO,tsreset,0,seltrue,\
		NO,0}
#else
#define	TS_BDEV	UNUSED_BDEV
#define	TS_CDEV	UNUSED_CDEV
#endif
 
#include "pty.h"
#if NPTY > 0 || Npty > 0
int	ptsopen(),ptsclose(),ptsread(),ptswrite(),ptsstop();
int	ptcopen(),ptcclose(),ptcread(),ptcwrite(),ptcselect();
int	ptyioctl();
struct	tty pt_tty[];
#define	PTS_CDEV {ptsopen,ptsclose,ptsread,ptswrite,ptyioctl,ptsstop,NU,pt_tty,\
		ttselect,NO,0}
#define	PTC_CDEV {ptcopen,ptcclose,ptcread,ptcwrite,ptyioctl,NU,NU,pt_tty,\
		ptcselect,NO,0}
#else
#define	PTS_CDEV	{NO, NO, NO, NO, NO, NU, NU, 0, NO, NO,0}
#define	PTC_CDEV	UNUSED_CDEV
#endif

#ifdef	 ENETFILTER
int	enetopen(),enetclose(),enetread(),enetwrite(),enetioctl(),enetselect();
#define	ENET_CDEV {enetopen,enetclose,enetread,enetwrite,enetioctl,NU,NU,0,\
		enetselect,NO,0}
#else
#define	ENET_CDEV	UNUSED_CDEV
#endif

#include "sp.h"
#if NSP > 0 || Nsp > 0
int	spopen(),spstrategy(),spread(),spwrite(),spioctl(),spsize();
#define	SP_BDEV	{spopen,NU,spstrategy,NU,spsize,0}
#define	SP_CDEV	{spopen,NU,spread,spwrite,spioctl,NO,NU,0,seltrue,NO,0}
#else
#define	SP_BDEV	UNUSED_BDEV
#define	SP_CDEV	UNUSED_CDEV
#endif


#ifdef	QBUS
/* ------------ QBUS BUS DEVICES ------------- */
#include "el.h"
#if NEL > 0 || Nel > 0
int	elopen(),elstrategy(),elread(),elwrite(),elioctl(),elreset(),eldump(),elsize();
#define	EL_BDEV	{elopen,NU,elstrategy,eldump,elsize,0}
#define	EL_CDEV	{elopen,NU,elread,elwrite,elioctl,NO,elreset,0,seltrue,NO,0}
#else
#define	EL_BDEV	UNUSED_BDEV
#define	EL_CDEV	UNUSED_CDEV
#endif

#include "hp.h"
#if NHP > 0 || Nhp > 0
int	hpopen(),hpstrategy(),hpread(),hpwrite(),hpreset(),hpdump(),hpioctl(),hpsize();
#define	HP_BDEV	{hpopen,NU,hpstrategy,hpdump,hpsize,0}
#define	HP_CDEV	{hpopen,NU,hpread,hpwrite,hpioctl,NO,hpreset,0,seltrue,NO,0}
#else
#define	HP_BDEV	UNUSED_BDEV
#define	HP_CDEV	UNUSED_CDEV
#endif

#include "rk.h"
#if NRK > 0 || Nrk > 0
int	rkopen(),rkstrategy(),rkread(),rkwrite(),rkdump(),rkreset(),rksize();
#define	RK_BDEV {rkopen,NU,rkstrategy,rkdump,rksize,0}
#define	RK_CDEV {rkopen,NU,rkread,rkwrite,NO,NO,rkreset,0,seltrue,NO,0}
#else
#define	RK_BDEV	UNUSED_BDEV
#define	RK_CDEV	UNUSED_CDEV
#endif

#include "ra.h"
#if NRA > 0 || Nra > 0
int	raopen(),rastrategy(),raread(),rawrite(),rareset(),radump(),rasiz();
#define	RA_BDEV	{raopen,NU,rastrategy,radump,rasize,0}
#define	RA_CDEV	{raopen,NU,raread,rawrite,NO,NO,rareset,0,seltrue,NO,0}
#else
#define	RA_BDEV	UNUSED_BDEV
#define	RA_CDEV	UNUSED_CDEV
#endif

#include "rl.h"
#if NRL > 0 || Nrl > 0
int	rlopen(),rlstrategy(),rlread(),rlwrite(),rlreset(),rldump(),rlsize();
#define	RL_BDEV	{rlopen,NU,rlstrategy,rldump,rlsize,0}
#define	RL_CDEV	{rlopen,NU,rlread,rlwrite,NO,NO,rlreset,0,seltrue,NO,0}
#else
#define	RL_BDEV	UNUSED_BDEV
#define	RL_CDEV	UNUSED_CDEV
#endif

#include "rx.h"
#if NRX > 0 || Nrx > 0
int	rxopen(),rxstrategy(),rxclose(),rxread(),rxwrite(),rxreset(),rxioctl();
#define	RX_BDEV	{rxopen,rxclose,rxstrategy,NO,0,B_18BIT}
#define	RX_CDEV	{rxopen,rxclose,rxread,rxwrite,rxioctl,NO,rxreset,0,seltrue,\
		NO,0}
#else
#define	RX_BDEV	UNUSED_BDEV
#define	RX_CDEV	UNUSED_CDEV
#endif

#include "tm.h"
#if NTM > 0 || Ntm > 0
int	tmopen(),tmclose(),tmstrategy(),tmread(),tmwrite(),
	tmioctl(),tmdump(),tmreset();
#define	TM_BDEV	{tmopen,tmclose,tmstrategy,tmdump,0,B_18BIT|B_TAPE}
#define	TM_CDEV	{tmopen,tmclose,tmread,tmwrite,tmioctl,NO,tmreset,0,seltrue,\
		NO,0}
#else
#define	TM_BDEV	UNUSED_BDEV
#define	TM_CDEV	UNUSED_CDEV
#endif

#include "dz.h"
#if NDZ > 0 || Ndz > 0
int	dzopen(),dzclose(),dzread(),dzwrite(),dzioctl(),dzstop(),dzreset();
struct	tty dz_tty[];
#define	DZ_CDEV	{dzopen,dzclose,dzread,dzwrite,dzioctl,dzstop,dzreset,dz_tty,\
		ttselect,NO,0}
#else
#define	DZ_CDEV	UNUSED_CDEV
#endif

#include "dh.h"
#if NDH > 0 || Ndh > 0
int	dhopen(),dhclose(),dhread(),dhwrite(),dhioctl(),dhstop(),dhreset();
struct	tty dh_tty[];
#define	DH_CDEV	{dhopen,dhclose,dhread,dhwrite,dhioctl,dhstop,dhreset,dh_tty,\
		ttselect,NO,0}
#else
#define	DH_CDEV	UNUSED_CDEV
#endif

#include "dhv.h"
#if NDHV > 0 || Ndhv > 0
int	dhv_open(),dhv_close(),dhv_read(),dhv_write(),dhv_ioctl(),dhv_stop(),
	dhv_reset();
struct	tty dhv_tty[];
#define DHV_CDEV {dhv_open,dhv_close,dhv_read,dhv_write,dhv_ioctl,dhv_stop,\
		  dhv_reset,dhv_tty,ttselect,NO,0}
#else
#define DHV_CDEV UNUSED_CDEV
#endif

#include "lp.h"
#if NLP > 0 || Nlp > 0
int	lpopen(),lpclose(),lpwrite(),lpreset();
#define	LP_CDEV	{lpopen,lpclose,NO,lpwrite,NO,NO,lpreset,0,seltrue,NO,0}
#else
#define	LP_CDEV	UNUSED_CDEV
#endif

#include "dl.h"
#if NDL > 0 || Ndl > 0
int	dlopen(),dlclose(),dlread(),dlwrite(),dlioctl(),dlstop(),dlreset();
struct	tty dl_tty[];
#define	DL_CDEV	{dlopen,dlclose,dlread,dlwrite,dlioctl,dlstop,NU,dl_tty,\
		ttselect,NO,0}
#else
#define	DL_CDEV	UNUSED_CDEV
#endif

#include "ib.h"
#if NIB > 0 || Nib > 0
int	ibopen(),ibclose(),ibread(),ibwrite(),ibioctl();
#define	IB_CDEV	{ibopen,ibclose,ibread,ibwrite,ibioctl,NO,NU,0,seltrue,NO,0}
#else
#define	IB_CDEV	UNUSED_CDEV
#endif

#include "rp.h"
#if NRP > 0 || Nrp > 0
int	rpopen(),rpclose(),rpread(),rpwrite(),rpioctl();
#define	RP_CDEV	{rpopen,rpclose,rpread,rpwrite,rpioctl,NO,NU,0,seltrue,NO,0}
#else
#define	RP_CDEV	UNUSED_CDEV
#endif

#include "axv.h"
#if NAXV > 0 || Naxv > 0
int	axvopen(),axvclose(),axvread(),axvwrite(),axvioctl(),axvreset();
#define	AXV_CDEV {axvopen,axvclose,axvread,axvwrite,axvioctl,NO,axvreset,0,\
seltrue,NO,0}
#else
#define	AXV_CDEV UNUSED_CDEV
#endif

#else	QBUS
/* ----------- VME BUS BUS DEVICES ----------- */

#include "sd.h"
#if NSD > 0 || Nsd > 0
int	sdopen(),sdstrategy(),sdread(),sdwrite(),sdioctl(),sdreset(),sddump(),sdsize();
#define	SD_BDEV	{sdopen,NU,sdstrategy,sddump,sdsize,0}
#define	SD_CDEV	{sdopen,NU,sdread,sdwrite,sdioctl,NO,sdreset,0,seltrue,NO,0}
#else
#define	SD_BDEV	UNUSED_BDEV
#define	SD_CDEV	UNUSED_CDEV
#endif

#include "sm.h"
#if NSM > 0 || Nsm > 0
int	smopen(),smstrategy(),smread(),smwrite(),smioctl(),smreset(),smdump(),smsize();
#define	SM_BDEV	{smopen,NU,smstrategy,smdump,smsize,0}
#define	SM_CDEV	{smopen,NU,smread,smwrite,smioctl,NO,smreset,0,seltrue,NO,0}
#else
#define	SM_BDEV	UNUSED_BDEV
#define	SM_CDEV	UNUSED_CDEV
#endif

#include "gd.h"
#if NGD > 0 || Ngd > 0
int	gdopen(),gdstrategy(),gdread(),gdwrite(),gdioctl();
int	gdreset(),gddump(),gdsize();
#define	GD_BDEV	{gdopen,NU,gdstrategy,gddump,gdsize,0}
#define	GD_CDEV	{gdopen,NU,gdread,gdwrite,gdioctl,NO,gdreset,0,seltrue,NO,0}
#else
#define	GD_BDEV	UNUSED_BDEV
#define	GD_CDEV	UNUSED_CDEV
#endif

#include "rf.h"
#if NRF > 0 || Nrf > 0
int	rfopen(),rfstrategy(),rfread(),rfwrite(),rfreset(),rfdump(),rfsizeof();
#define	RF_BDEV	{rfopen,NU,rfstrategy,rfdump,rfsizeof,0}
#define	RF_CDEV	{rfopen,NU,rfread,rfwrite,NO,NO,rfreset,0,seltrue,NO,0}
#else
#define	RF_BDEV	UNUSED_BDEV
#define	RF_CDEV	UNUSED_CDEV
#endif

#include "cp.h"
#if NCP > 0 || Ncp > 0
int	cpopen(),cpclose(),cpread(),cpwrite(),cpioctl(),cpstop(),cpreset();
struct	tty cp_tty[];
#define	CP_CDEV	{cpopen,cpclose,cpread,cpwrite,cpioctl,cpstop,cpreset,cp_tty,\
		ttselect,NO,0}
#else
#define	CP_CDEV	UNUSED_CDEV
#endif

#ifdef	GWS
int	vtopen(),vtclose(),vtread(),vtwrite(),vtioctl();
struct	tty vt_tty[];
int	fntopen(),fntclose(),fntread(),fntwrite(),fntioctl();
#define	VT_CDEV	{vtopen,vtclose,vtread,vtwrite,vtioctl,NU,NU,vt_tty,ttselect,\
		NO,0}
#define	FNT_CDEV {fntopen,fntclose,fntread,fntwrite,fntioctl,NU,NU,0,seltrue,\
		NO,0}
#else
#define	RP_CDEV	UNUSED_CDEV
#endif

/*#include "enp.h" /**/
#if NENP > 0
int	enpioctl(), enpreconfig(), enpr_read(), enpr_write(), enpr_ioctl();
#define	ENP_CDEV {NU,NU,NO,NO,enpioctl,NO,NU,0,NO,NO}
#define	ENPR_CDEV {NU,NU,enpr_read,enpr_write,enpr_ioctl,NO,NU,0,NO,NO,0}
#else
#define	ENP_CDEV	UNUSED_CDEV
#define	ENPR_CDEV	UNUSED_CDEV
#endif

#include "nw.h"
#if NNW > 0
int	nwioctl(), nwreconfig(), nwr_read(), nwr_write(), nwr_ioctl();
#define	NWR_CDEV {NU,NU,nwr_read,nwr_write,nwr_ioctl,NO,NU,0,NO,NO,0}
#else
#define	NW_CDEV	UNUSED_CDEV
#define	NWR_CDEV UNUSED_CDEV
#endif
#endif	QBUS

#include "gg.h"
#if NGG > 0 || Ngg > 0
int	ggopen(), ggclose(), ggread(), ggwrite(), ggioctl();
#define	GG_CDEV	{ggopen,ggclose,ggread,ggwrite,ggioctl,NO,NU,0,seltrue,NO,0}
#else
#define	GG_CDEV	UNUSED_CDEV
#endif

struct bdevsw	bdevsw[] = {
	SWAP_BDEV,						/*0*/
#ifdef	QBUS
	EL_BDEV, HP_BDEV, RK_BDEV, RA_BDEV, RL_BDEV,		/*1-5*/
#else	QBUS
	SD_BDEV, SM_BDEV, GD_BDEV, RF_BDEV, UNUSED_BDEV,	/*1-5*/
#endif	QBUS
	RD_BDEV,						/*6*/
#ifdef	QBUS
	RX_BDEV, TM_BDEV,					/*7-8*/
#else	QBUS
	UNUSED_BDEV, UNUSED_BDEV,				/*7-8*/
#endif	QBUS
	TS_BDEV,						/*9*/
	SP_BDEV,						/* KLUDGE 10 */

};
int	nblkdev = sizeof (bdevsw) / sizeof (bdevsw[0]);

#define	CONS_MAJ	10
#define	MEM_MAJ		12

struct cdevsw	cdevsw[] = {
	SWAP_CDEV,						/*0*/
#define	SWAP_MAJ	0
#ifdef	QBUS
	EL_CDEV, HP_CDEV, RK_CDEV, RA_CDEV, RL_CDEV,		/*1-5*/
#else	QBUS
	SD_CDEV, SM_CDEV, GD_CDEV, RF_CDEV, UNUSED_CDEV,	/*1-5*/
#endif	QBUS
    	RD_CDEV, 						/*6*/
#define	TRFS_MAJ	6
#ifdef	QBUS
	RX_CDEV, TM_CDEV,					/*7-8*/
#else	QBUS
	UNUSED_CDEV, UNUSED_CDEV,				/*7-8*/
#endif	QBUS
	TS_CDEV, SIO_CDEV, SY_CDEV, MEM_CDEV,			/*9-12*/
#ifdef	QBUS
	DZ_CDEV, DH_CDEV, LP_CDEV,				/*13-15*/
#else	QBUS
	UNUSED_CDEV, CP_CDEV, UNUSED_CDEV,			/*13-15*/
#endif	QBUS
	PTS_CDEV, PTC_CDEV,					/*16-17*/
#ifdef	QBUS
	DL_CDEV, IB_CDEV,					/*18-19*/
#else	QBUS
	UNUSED_CDEV, UNUSED_CDEV,				/*18-19*/
#endif	QBUS
	ENET_CDEV,						/*20*/
#ifdef	GWS
	VT_CDEV, FNT_CDEV,					/*21-22*/
#else	GWS
	RP_CDEV, UNUSED_CDEV, 					/*21-22*/
#endif	GWS
#ifdef	QBUS
    	DHV_CDEV, AXV_CDEV,	  				/*23-24*/
#else	QBUS
    	ENP_CDEV, ENPR_CDEV, 					/*23-24*/
#endif	QBUS
    	SP_CDEV, 						/*25*/
#ifdef	QBUS
    	UNUSED_CDEV, UNUSED_CDEV,				/*26-27*/
#else	QBUS
    	NWR_CDEV, GG_CDEV,					/*26-27*/
#endif	QBUS
    	LOG_CDEV, 						/*28*/
    	UNUSED_CDEV, UNUSED_CDEV, UNUSED_CDEV, UNUSED_CDEV,	/*29-32*/
    	UNUSED_CDEV, UNUSED_CDEV, UNUSED_CDEV, UNUSED_CDEV,	/*33-36*/
    	UNUSED_CDEV, UNUSED_CDEV,				/*37-38*/
};
int	nchrdev = sizeof (cdevsw) / sizeof (cdevsw[0]);

/*
 * Swapdev is a fake device implemented in sw.c used only internally to get to 
 * swstrategy. It cannot be provided to the users, because the swstrategy 
 * routine munches the b_dev and b_blkno entries before calling the appropriate
 * driver.  This would horribly confuse, e.g. the hashing routines. Instead, 
 * /dev/drum is provided as a character (raw) device.
 */
dev_t	swapdev= makedev(SWAP_MAJ, 0);
int	console_no = CONS_MAJ;	/* major device number of console */
int	mem_no = MEM_MAJ; 	/* major device number of memory special file */
#ifdef	TRFS
int	trfs_no = TRFS_MAJ;	/* major device number of network swap device */
#endif	TRFS

