/*
 * Copyright (c) 1980 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)locore.s	6.36 (Berkeley) 3/12/86
 */
#define FP_68881	/* comment to disable 68881 save/restore on switch */
#define FP_SKY  	/* comment to disable sky save/restore on switch */
/*#define KPROF	0x10000	/* enable kernel profiling */
/*#define C_newptes	/**/

#include "errno.h"
#include "param.h"
#include "psl.h"
#include "pte.h"
#include "pcb.h"
#include "trap.h"
#include "scb.h"
#include "board.h"
#include "../is68kdev/sioreg.h"
#include <syscall.h>
#ifdef	FP_SKY
#include "../is68kdev/skyreg.h"
#endif	FP_SKY

/* DEVICE SPECIFIC */
#include "gp.h"				/* VMEBUS */
#include "vb.h"				/* VMEBUS */
#include "nw.h"				/* VMEBUS */

/*
 *	Debug trace skeleton and flags:
 *		TRACE(<ea>)
 *		Printn(reg, scratch_D_reg, scratch_D_reg, scratch_A_reg)
 */
#define	TXW		9: btst #2,S2681_R_SR_A; jeq 9b; /* wait for transmit */
#define	TRACE(x)	TXW; movb x,S2681_W_THR_A
#define	PN(X,Y,Z)	roll #4,X; movb X,Y; andw #0xF,Y; TRACE(Z@(0,Y:w))
#define	Printn(W,X,Y,Z) movl #N2C,X;andl #0xFFFFFFF,X;movl X,Z;movl W,X; \
			TRACE(#0x7b);PN(X,Y,Z);PN(X,Y,Z);PN(X,Y,Z);PN(X,Y,Z); \
			PN(X,Y,Z);PN(X,Y,Z);PN(X,Y,Z);PN(X,Y,Z);TRACE(#0x7d)

	.globl	_vme_short
	.globl	_vme_std
	.globl	_vme_stdio
	.globl	_vme_ext
	.set	_vme_short,VME_SHORTIO
	.set	_vme_std,VME_STANDARD
	.set	_vme_stdio,VME_STANDARD
	.set	_vme_ext,VME_EXTENDED

/*
 * System page table, must begin on a page boundary
 */
#define	vaddr(x)	(((((x) - _Sysmap) / 4 ) * NBPG ) + SYSV_BASE)
	.set	pteindx,	SYSV_BASE + NBPG

#define	SYSMAP(mname, vname, npte)					\
	.globl	_/**/mname;						\
	.globl	_/**/vname;						\
	.globl	_TBUF_S_/**/vname;					\
	.set	_/**/mname,	pteindx;				\
	.set	_/**/vname,	vaddr(_/**/mname);			\
	.set	_TBUF_S_/**/vname,TBUF_BASE_SYS|(_/**/vname&TBUF_INDEX_MASK);	\
	.set	pteindx,	pteindx + ((npte) * 4);

	SYSMAP(Sysmap		,Sysbase	,SYSPTSIZE )
	SYSMAP(Usrptmap		,usrpt		,USRPTSIZE )
	SYSMAP(Umap		,u		,UPAGES )
	SYSMAP(Forkmap		,forkutl	,UPAGES )
	SYSMAP(Xswapmap		,xswaputl	,UPAGES )
	SYSMAP(Xswap2map	,xswap2utl	,UPAGES )
	SYSMAP(Swapmap		,swaputl	,UPAGES )
	SYSMAP(Pushmap		,pushutl	,UPAGES )
	SYSMAP(Vfmap		,vfutl		,UPAGES )
	SYSMAP(mcrmap		,mcr		,1 )
	SYSMAP(mmap		,vmmap		,1 )
	SYSMAP(msgbufmap	,msgbuf		,MSGBUFPTECNT )
	SYSMAP(camap		,cabase		,16*CLSIZE )
	SYSMAP(ecamap		,calimit	,0 )
	SYSMAP(Mbmap		,mbutl		,NMBCLUSTERS*CLSIZE+CLSIZE )
#ifndef	is68k_kobj
#if	NGP > 0
	SYSMAP(vidbufmap	,vidbuf    	,NGP*((1024*1024)/NBPG))
#endif	NGP > 0
#if	NVB > 0
	SYSMAP(vbmap		,vb		,(256*1024)/NBPG)
#endif	NVB > 0
#if	NNW > 0
	SYSMAP(nwmap0		,nw0		,(256*1024)/NBPG)
	SYSMAP(nwmap1		,nw1		,(256*1024)/NBPG)
#endif	NNW > 0
#endif	is68k_kobj
	SYSMAP(usrdevmap	,usrdev		,(1024*1024)/NBPG)
	SYSMAP(eSysmap		,esysmap	,0 )

	.globl	_Syssize
	.set	_Syssize,(_eSysmap - _Sysmap) / 4

#define	FC_UD		0x1		/* function code for user data */
#define	FC_UC		0x2		/* function code for user code */
#define	PSL_IPLN	PSL_IPL2	/* must be higher than PSL_IPLC */
#define	PSL_IPLS	PSL_IPL2	/* must be higher than PSL_IPLC */
#define	PSL_IPLC	PSL_IPL1
#define	SCRATCH_STACK	NBPG		/* before pte's */

	.text
	.globl	start
/*
 * Initialization
 */
start:	movw	#PSL_IPL7,sr		/* make sure interrupts are disabled */
	lea	SCRATCH_STACK,sp	/* temporary stack */

	/* 
	 * Set up scb so if we trap out we end up in the PROM, for DEBUG.
	 */
	lea	0,a0
	movl	a0,vb			/* set vector base register to 0 */
	clrl	a0@+
	clrl	a0@+
	movw	#NSCBVEC-1-2,d0
	lea	PROM_REBOOT,a1
    1:	movl	a1,a0@+
	dbra	d0,1b

	movl	#CCACHE_CLEAR|CCACHE_ENABLE,d0
	movec	d0,cac			/* clear and enable cache */

	/*
	 * Set context register and source/destination function codes for "movs"
	 */
	movl	#FC_UD,d0
	movl	d0,sfc			/* set source/destination function */
	movl	d0,dfc			/* code registers to user data */

#ifdef	M68025
	/*
	 * program the VDMA map for all valid 1:1 translation
	 */
	movl	#VDMA_BASE,a0
	movl	#VDMA_VALID,d0
	movl	#NVDMAS-1,d1
    1:	movl	d0,a0@
	addl	#VDMA_INCR,a0
	addl	#1,d0
	dbra	d1,1b

	/*
	 * Invalidate the EXTERNAL CACHE
	 */
	movl	#CTAG_A_BASE,a0
	movl	#CTAG_B_BASE,a1
	movl	#CTAG_INVALID,d0
	movl	#NCTAGS-1,d1
    1:	movl	d0,a0@
	addl	#CTAG_INCR,a0
	movl	d0,a1@
	addl	#CTAG_INCR,a1
	dbra	d1,1b
#endif	M68025

	/*
	 * Initialize portion of Sysmap used for Sysmap itself: kernel code, 
	 * data, and bss.
 	 */
	movl	#_Sysmap,d0
	andl	#NONT_MASK,d0
	movl	d0,a0
	movl	d0,a1
	movl	#_Sysbase,d0		/* Base of mapped region */
	movl	#_end+NBPG-1,d1
	subl	d0,d1
	andl	#(NONT_MASK&(~(NBPG-1))),d0
	movl	#PGSHIFT,d2
	lsrl	d2,d0
	orl	#PG_V|PG_KW|PG_CACHEK,d0
	lsrl	d2,d1
	subl	#1,d1
    1:	movl	d0,a0@+
	addl	#1,d0
	dbra	d1,1b

	movl	#PG_KR,d0		/* invalidate to PTP pointer boundary */
    1:	movl	a0,d1
	andl	#PTP_LSBMASK-1,d1
	jeq	1f
	movl	d0,a0@+
	jra	1b

	/* 
	 * turn off cache bits for pte's which map the system pte's
	 */
    1:	movl	#_Sysmap,d0
	movl	d0,d1
	andl	#(NONT_MASK&(~(NBPG-1))),d1
	lsrl	d2,d1
	lsll	#2,d1
	addl	a1,d1
	movl	d1,a0			/* Sysmap entry for Sysmap */
	movl	#_Syssize,d1		/* # of pte's in sysmap */
	lsll	#2,d1			/* # of bytes of pte's in Sysmap */
	addl	#NBPG-1,d1
	lsrl	d2,d1			/* number of pte's to map Sysmap */
	subl	#1,d1
    1:	movl	a0@,d0
	andl	#~PG_CACHEK,d0		/* turn off cache */
	movl	d0,a0@+
	dbra	d1,1b

	/*
	 * Write protect as much kernel code as possible. NOTE: kernel is a
	 * 407 image so there is no padding between text and data, leaving a
	 * small portion of kernel code which could be overwritten.
	 */
	movl	#start,d0
	movl	d0,d1
	andl	#(NONT_MASK&(~(NBPG-1))),d1
	lsrl	d2,d1
	lsll	#2,d1
	addl	a1,d1
	movl	d1,a0			/* Sysmap entry for start */
	movl	#_etext,d1
	subl	d0,d1
	lsrl	d2,d1
	subl	#1,d1
    1:	movl	a0@,d0
	andl	#~PG_PROT,d0		/* remove old protection */
	orl	#PG_KR,d0		/* add new protection */
	movl	d0,a0@+
	dbra	d1,1b

	/*
	 * Invalidate PTP's of all contexts
	 */
	movl	#PTP_INVALID,d1
	movl	#NCTX-1,d2
	movl	#PTP_INCR,d3
    1:	movb	d2,CTX
	movl	#NPTPS-1,d0
	lea	PTP_BASE,a0
    2:	movl	d1,a0@
	addl	d3,a0
	dbra	d0,2b
	dbra	d2,1b

	/*
	 * Invalidate system and user TBUF
	 */
	movl	#TBUF_INVALID,d1
	movl	#TBUF_INCR,d2
	lea	TBUF_BASE_SYS,a0
	lea	TBUF_BASE_USR,a1
	movl	#NTBUFS-1,d0
    1:	movl	d1,a0@;		addl	d2,a0
	movl	d1,a1@;		addl	d2,a1
	dbra	d0,1b

	/*
	 * Initialize system (context 0) PTP to point to Sysmap; context 0
	 * PTP is never touched again!
	 */
	lea	PTP_BASE,a0
	movl	#_Sysmap,d0
	andl	#PTP_ADRMASK,d0
	movl	#PTP_ADRSHIFT,d1
	lsrl	d1,d0
	movl	#_Syssize,d1		/* number of pte's in sysmap */
	movl	#(PGSHIFT-2)-1,d2
	lsrl	d2,d1			/* number of ptp's to map to pte's */
    1:	movl	d0,d2
	lsrl	#1,d2
	jcc	2f
	orl	#PTP_LSB,d2
    2:	orl	#PTP_VALID,d2
	movl	d2,a0@
	addl	#PTP_INCR,a0
	addl	#1,d0
	dbra	d1,1b

	/*******************************************************************
	 * Now able to reference kernel link space (system virtual) memory *
	 *******************************************************************/
	/*
	 * Size and zero non translated memory, starting at _edata.
	 * This will clear kernel BSS.
	 */
	movl	#_edata,d0
	andl	#NONT_MASK,d0
	movl	d0,a0
	movl	#0xCACAFECE,d0
	lea	0+SCB_BUSERR,a1		/* reprogram bus error vector */
	movl	a1@,d1
	movl	#2f,a1@
    1:	movl	d0,a0@
	cmpl	a0@,d0
	jne	2f
	clrl	a0@+
	jra	1b			/* clear until bus error */

	/*******************************************************************
	 * Now able to reference kernel BSS space                          *
	 *******************************************************************/
    2:	movl	d1,a1@
	movl	a0,d0
	movl	#PGSHIFT,d1
	lsrl	d1,d0
	subl	_detachedmem,d0
	movl	d0,_maxmem
	movl	d0,_physmem
	movl	d0,_freemem
	movl	d7,_howto		/* PROM arguments: how to boot */
	movl	d6,_devtype		/* major number of boot device */
#ifdef	M68025
	movl	_cache_enable,d0
	orl	#BSR_W_MOTCACHE|BSR_W_LED0|BSR_W_LED1,d0
	movb	d0,_bsr
	movb	d0,BSR
#endif	M68025

	/*
	 * Allocate and setup page table and _u area for proc[0]. 
	 */
	movl	#_end+NBPG-1,d0		/* first page for proc 0 page table */
	andl	#(NONT_MASK&(~(NBPG-1))),d0
	movl	#PGSHIFT,d1
	lsrl	d1,d0
	movl	d0,d2
	orl	#PG_V|PG_KW,d0
	movl	d0,_Usrptmap		/* map it into _usrpt */

	lea	_usrpt+NBPG-(UPAGES*4),a0/* last ptes are for _u area */
	lea	_Umap,a1		/* map also to _u */
	orl	#PG_CACHEK,d0
	movl	#UPAGES-1,d1
    1:	addl	#1,d0
	movl	d0,a0@+
	movl	d0,a1@+
	dbra	d1,1b

	lea	_u+(UPAGES*NBPG),sp	/* set stack pointer to top of _u */

	/* 
	 * Initialize (slightly) the pcb
	 */
	lea	_u,a0
	movl	sp,a0@(PCB_SP)
	movw	sr,a0@(PCB_PSL+2)
	movl	#_usrpt,a0@(PCB_P0BR)
	movl	#AST_NONE+0,a0@(PCB_P0LR)
	movl	#_usrpt+(MAXU_ADDR>>PGSHIFT)-(4*UPAGES),a0@(PCB_P1BR)
	movl	#(MAXU_ADDR>>PGSHIFT)-UPAGES,a0@(PCB_P1LR)
	movl	#1,a0@(PCB_SZPT)
	movl	#U_REDZONE_MAGIC,a0@(U_STACK)

	/*
	 * copy the template scb to vector base region (location 0).
	 */
	lea	0,a1
	clrl	a1@+
	movl	#0x4e4f4e4f,a1@+	/* trap #15, trap #15 catch jump 0 */
	lea	_scb+(2*4),a0
	movw	#NSCBVEC-2-1,d0
    1:	movl	a0@+,a1@+
	dbra	d0,1b

	TRACE(#0xA); TRACE(#0xD);	/* Output "\n" */
	addl	#UPAGES+1,d2
	movl	d2,sp@-

	.globl	_START
_START:	jsr	_main
	addl	#4,sp

	lea	NBPG,a0
	movl	a0,usp
	movw	#0,sp@-
	pea	0			/* user pc */
	movw	#PSL_USERSET,sp@-
	rte				/* go run icode */

	.globl	_DELAY
_DELAY:	movl	_cpuspeed,d1
    1:	movl	sp@(4),d0
    2:	dbf	d0,2b
	addw	#1,d0
	subl	#1,d0
	jge	2b
	dbf	d1,1b
	addw	#1,d1
	subl	#1,d1
	jge	1b
	rts

/************************************************************************/

/*
 * Interrupt vector routines. Following globals are for convienience in namelist
 */
	.globl	_waittime
	.globl	traps
	.globl	iret
	.globl	dorte

#define	SCBVEC(name)	.align 1;  .globl _X/**/name;  _X/**/name
#define	TRAP(x)		PEEXT(x); jra traps
#define	PEEXT(x)	clrw sp@-; pea x	/* push exception extention */
#define	PUSHR		movml #<d0-d1,a0-a1>,sp@-
#define	POPR		movml sp@+,#<d0-d1,a0-a1>
#define	PUSHED		(4*4)			/* offset around saved regs */
#define	TCODE		PUSHED			/* offset to trap code */
#define	TTYPE		(PUSHED+2)		/* offset to trap type */
#define	EEXT		6			/* size exception extension */
#define	ESF		(EEXT+PUSHED)		/* offset to exception frame */
#define	INC(counter)	addl #1,_cnt+counter	/* increment event counter */
#define	IBEG		IINC; subl #EEXT,sp; PUSHR; /* start of interrupt */
#define	RTE(n)		IDEC; INC(n); jra iret	/* end of interrupt */
#define	IINC		addl #1,_int_svc	/* increment interrupt depth */
#define	IDEC		subl #1,_int_svc	/* decrement interrupt depth */

/*
 * collapse various stack formats to 4-word format 0 if ESF_SOFT bit is on in 
 * the stack format/vector offset word. Used to send signals to process, and 
 * for nofault recovery.
 */
#define	COLLAPSE(x)	\
    5:	cmpw	#ESF_FMT/**/x,sp@(ESF_VEC); jne 5f; /* stack format x to */    \
	movw	#ESF_FMT0,sp@(ESF_VEC+ESF_ISIZE/**/x-ESF_ISIZE0); /* fmt0 */   \
	movl	sp@(ESF_PC),sp@(ESF_PC+ESF_ISIZE/**/x-ESF_ISIZE0);/* copy pc */\
	movw	sp@(ESF_SW),sp@(ESF_SW+ESF_ISIZE/**/x-ESF_ISIZE0);/* copy sr */\
	lea	sp@(ESF_ISIZE/**/x-ESF_ISIZE0),sp; jra 2b /* collapse size */

SCBVEC(stray):		TRAP(T_STRAY)
SCBVEC(adderr):		TRAP(T_ADDERR)
SCBVEC(illins):		TRAP(T_RESOPFLT)
SCBVEC(zerodiv):	TRAP(T_ZERODIV)
SCBVEC(chk):		TRAP(T_CHK)
SCBVEC(trapv):		TRAP(T_TRAPV)
SCBVEC(privvio):	TRAP(T_PRIVINFLT)
SCBVEC(l1010em):	TRAP(T_L1010EM)
SCBVEC(l1111em):	TRAP(T_L1111EM)
SCBVEC(fmterr):		TRAP(T_FMTERR)
SCBVEC(coproc):		TRAP(T_COPROC)
SCBVEC(fpe):		TRAP(T_FPE)
SCBVEC(trap0):		TRAP(T_TRAP+(0<<16))
SCBVEC(trap9):		TRAP(T_TRAP+(9<<16))
SCBVEC(trap10):		TRAP(T_TRAP+(10<<16))
SCBVEC(trap11):		TRAP(T_TRAP+(11<<16))
SCBVEC(trap12):		TRAP(T_TRAP+(12<<16))
SCBVEC(trap13):		TRAP(T_TRAP+(13<<16))
SCBVEC(trap14):		TRAP(T_TRAP+(14<<16))
SCBVEC(trap15):
#ifdef	DEBUGGER
			btst	#5,sp@; jne	dbg_excpt
#endif
			TRAP(T_BPTFLT)
SCBVEC(trace):
			/* ignore trace traps if trace bit is not set! */
			btst	#7,sp@; jne	1f; rte
#ifdef	DEBUGGER
    1:			btst	#5,sp@; jne	dbg_excpt
#endif
    1:			TRAP(T_TRCTRAP)

traps:	PUSHR				/* save [da][01] temporary registers */
traps0:	movl	usp,a0			/* save user sp */
	pea	a0@
	jsr	_trap			/* call generic trap handler */
	movl	sp@+,a0
	movl	a0,usp			/* restore user sp */
	INC	(V_TRAP)		/* keep count */

iret:	movw	#PSL_IPL7,sr		/* raise priority to protect ast */
	tstb	_ast
	jne	6f			/* branch if pending async soft trap */
    1:	POPR				/* restore [da][01] */
	addl	#EEXT,sp		/* pop exception extention */

dorte:	bclr	#ESF_SOFT_BIT,sp@(ESF_VEC)
	jne	5f			/* branch if frame must be collapsed */

	/* check for excessive stack growth, clobbering u area */
    2:	cmpl	#U_REDZONE_MAGIC,_u+U_STACK
	jne	3f

	/* chech for stack pointer getting near uarea */
	cmpl	#_u+U_STACK+512,sp
	jgt	4f
	cmpl	#SCRATCH_STACK,sp
	jlt	4f
    3:	tstl	_panicstr		/* disregaurd on panic */
	jne	4f
	pea	panic_stackovf		/* kernel stack overflow!! */
	jsr	_panic
    4:	rte				/**** return from trap/interrupt ****/

    5:	andw	#ESF_FMTMSK,sp@(ESF_VEC)/* isolate stack format */
	cmpw	#ESF_FMT0,sp@(ESF_VEC)	/* format 0 does not collapse */
	jeq	2b

	COLLAPSE(A)
	COLLAPSE(B)
	COLLAPSE(9)
	COLLAPSE(2)

    5:	pea	panic_iret		/* bad stack format */
	jsr	_panic

	/* Handle asynchronious soft trap */
    6:	movw	sp@(ESF+ESF_SW),d0
	andw	#PSL_HIGH,d0		/* are we returning to low priority? */
	jne	1b			/* no, leave ast pending */
	bclr	#AST_SOFT,_ast		/* check/clear software ast */
	jne	_Xsoftintr
	bclr	#AST_TIC,_ast		/* check/clear softclock ast */
	jne	_Xsoftclock
	btst	#AST_USR,_ast		/* check/clear user resched ast */
	jeq	1b
	movw	sp@(ESF+ESF_SW),d0	/* must be user ast */
	andw	#PSL_CURMOD,d0		/* leave pending */
	jne	1b			/* if not return to user mode */
	bclr	#AST_USR,_ast		/* clear ast and go service in trap */
	movw	#T_ASTFLT,sp@(TTYPE)
	jra	traps0

SCBVEC(nmi):
#ifndef	KPROF
#ifdef	DEBUGGER
#ifndef	M68025
	btst	#5,ESR			/* parity error ? */
	beqs	1f
	btst	#4,ESR			/* halt or ac powerfail ? */
	bnes	1f
#endif	M68025
	jra	dbg_excpt		/* nmi button ! */
    1:
#endif	DEBUGGER
	TRAP(T_NMI)
#else	KPROF
	/*
	 * To prepare QBUS 68010 CPU board for kprof profiling at level 7:
	 *	- Inject profile clock into 8A (8640) pin 7, BHALTL.
	 * To prepare VBUS 68010 CPU board for kprof profiling at level 7:
	 *	-  Bend up 9M (S113) pin 1 (AC fail), and inject profile clock 
	 *	   into chip pin.
	 * To prepare VBUS 68020 CPU board for kprof profiling at level 7:
	 *	-  Bend up U58 (LS32) pin 5, and ground that chip pin. This 
	 *	   disables latching of BSR on NMI interrupts, so that status 
	 *	   for bus errors is not lost.
	 *	-  Remove R5, which connects to AC fail on the bus. 
	 *	-  Inject profile clock into U82(LS113) pin 13.
	 */
	.data
	.globl	_kprof_magic
_kprof_magic:	.long	0x12345678
	.comm	_kprof_enable,4
	.comm	_kprof_su,2*4
	.comm	_kprof_spsl,8*4
	.comm	_kprof_upsl,8*4
	.comm	_kprof,KPROF*4
	.comm	_kprof_swtch,4
	.comm	_kprof_buse,4
	.comm	_kprof_sysc,4
	.comm	_kprof_pid,(20+32)*4	/* first 20 plus last 32 pid's */
	.comm	_kprof_pid_cnt,(20+32)*4
	.comm	_kprof_pid_nam,(20+32)*8
	.text

	IBEG
	tstb	_kprof_enable+3		/* skip if not enabled */
	jeq	3f
	cmpl	#SCRATCH_STACK,sp	/* dont look at pid if swtching */
	jlt	2f
	clrl	d0
	movl	_u+U_PROCP,a0		
	movw	a0@(P_PID),d0
	movl	d0,d1
	cmpw	#20,d0
	jle	1f
	andw	#0x1F,d0
	addl	#20,d0
    1:	lsll	#2,d0
	lea	_kprof_pid,a0
	addl	d0,a0
	movl	d1,a0@
	lea	_kprof_pid_cnt,a0
	addl	d0,a0
	addl	#1,a0@
	lea	_kprof_pid_nam,a0
	lsll	#1,d0
	addl	d0,a0
	lea	_u+U_COMM,a1		
	movl	a1@+,a0@+
	movl	a1@,a0@
    2:	clrl	d0
	movw	sp@(ESF+ESF_SW),d0	/* get psl */
	movw	d0,d1
	andl	#PSL_HIGH,d0
	lsrw	#PSL_IPL_SHIFT-2,d0	/* define kprof_[su]psl index */
	andl	#PSL_CURMOD,d1		/* test system mode */
	jeq	1f			/* jump if user mode */
	addl	#1,_kprof_su+4		/* accumulate system mode stats */
	jmi	4f;			/* jump if auto-shutoff */
	movl	sp@(ESF+ESF_PC),d1	/* get pc */
	andl	#NONT_MASK,d1
	lsrl	#2,d1			/* >>4, &(KPROF-1), <<2 */
	andl	#((KPROF-1)<<2),d1
	lea	_kprof,a0
	addl	d1,a0
	addl	#1,a0@
	lea	_kprof_spsl,a0
	jra	2f
    1:	addl	#1,_kprof_su		/* user mode */
	jmi	4f;			/* jump if auto-shutoff */
	lea	_kprof_upsl,a0
    2:	addl	d0,a0
	addl	#1,a0@
    3:	RTE	(V_INTR)
    4:	clrl	_kprof_enable		/* disable */
	RTE	(V_INTR)
#endif	KPROF

SCBVEC(clock):
	IBEG
#ifndef	is68k_kobj
#if	NVB > 0
	jsr	_vbcheck		/* 010's and standalone dont use IPI */
	subw	#1,tictoc
	jgt	1f
	movw	_fastclock,tictoc
#endif	NVB > 0
#endif	is68k_kobj
	movw	sp@(ESF+ESF_SW),sp@-
	clrw	sp@-
	movl	sp@(4+ESF+ESF_PC),sp@-
	jsr	_hardclock		/* hardclock(pc,psl) */
	addl	#8,sp
	addl	#1,_intrcnt+I_CLOCK
    1:	RTE	(V_INTR)		/* temp so not to break vmstat -= HZ */

/* 
 * AST HANDLERS: exception extension stuff and regs are already pushed
 */
SCBVEC(softclock):
	movw	#PSL_IPLC,sr
	movw	sp@(ESF+ESF_SW),sp@-
	clrw	sp@-
	movl	sp@(4+ESF+ESF_PC),sp@-
	jsr	_softclock		/* softclock(pc,psl) */
	addl	#8,sp
	jra	iret

SCBVEC(softintr):
	movw	#PSL_IPLS,sr
	jsr	_softint
	jra	iret

/*
 * T_CNTXFLT: attempt to access unallocated context
 * T_PAGEFLT: attempt to access valid logical location in paged out page
 * T_PROTFLT: attempt to write into a read-only page
 * T_SEGVIO:  attempt to access location outside of user address space
 * T_BUSERR:  attempt to access illegal/non existant memory
 * T_PARITY:  parity error occured
 */
SCBVEC(buserr):
#ifdef	KPROF
	tstb	_kprof_enable+3
	jeq	1f
	addl	#1,_kprof_buse		/* kprof: count bus errors */
    1:
#endif	KPROF
	PEEXT(T_PAGEFLT)		/* hopeful trap type */
	PUSHR
    	movb	ESR,d0
	btst	#ESR_ADDR_OK_BIT,d0	/* illegal address */
	jeq	2f
	btst	#ESR_HSBER_BIT,d0	/* 0 -> VME bus error */
	jeq	2f
#ifdef	M68025
	btst	#ESR_UPDATE_BIT,d0	/* 0 -> cache fill parity error */
	jeq	4f
	btst	#ESR_PARITY_OK_BIT,d0	/* 0 -> parity error */
	jeq	4f
#endif	M68025
	btst	#ESR_PTP_OK_BIT,d0	/* 0 -> PTP ABORT */
	jeq	3f
	btst	#ESR_PG_V_BIT,d0
	jne	1f
	jeq	traps0			/* trap with pagefault */

    1:	btst	#ESR_PROT_OK_BIT,d0
	jne	2f
	movw	#T_PROTFLT,sp@(TTYPE)
	jra	traps0
    2:	movw	#T_BUSERR,sp@(TTYPE)
	jra	traps0
    3:	movb	_ctx,d1			/* if CTX_INVALID, context fault */
	cmpb	#CTX_INVALID,d1
	jeq	1f
	movw	#T_SEGVIO,sp@(TTYPE)
	jra	traps0
    1:	movw	#T_CNTXFLT,sp@(TTYPE)
	jra	traps0
    4:	movw	#T_PARITY,sp@(TTYPE)
	jra	traps0

/*
 * System call service: Trap #1 is typical user system call. Signal and 
 * longjmp cleanup use traps #2 - #8, and go to Sigcleanup() via a 
 * negative-number syscall.  The traps are 4-word stack format 0, but may need 
 * to return with a larger stack format obtained from the user. Here we allocate
 * larger exception stack frame, slide the 4-word format up to the top of the 
 * allocated area, and change its format so that if it is actually used, it will
 * collapse back to 4 words.
 */
#define	SIG_CLEAN_SYSCALL(x,n)	\
	subl	#(ESF_ISIZE/**/x-ESF_ISIZE0),sp;/* allocate for format x */ \
	movw	sp@(ESF_SW+ESF_ISIZE/**/x-ESF_ISIZE0),sp@(ESF_SW);	\
	movl	sp@(ESF_PC+ESF_ISIZE/**/x-ESF_ISIZE0),sp@(ESF_PC);	\
	movw	#(ESF_SOFT|ESF_FMT/**/x),sp@(ESF_VEC);			\
	PEEXT(T_SYSCALL + (-n << 16)); jra 2b	/* syscall -n */


SCBVEC(trap1):
#ifdef	KPROF
	tstb	_kprof_enable+3
	jeq	1f
	addl	#1,_kprof_sysc		/* kprof: count system calls */
    1:
#endif	KPROF
	clrw	sp@-			/* align psl, part of EEXT */
	movw	#T_SYSCALL,sp@-		/* push type, part of EEXT */
	movw	d0,sp@-			/* push code, part of EEXT */
	jne	1f
	movw	d1,sp@
	movml	#<a0-a6>,_u+U_ARG
	jra	2f
    1:	movml	#<d1,a0-a6>,_u+U_ARG
    2:	PUSHR				/* save temp regs */
	movl	usp,a0			/* save user sp */
	pea	a0@
	jsr	_syscall		/* call system call handler */
	movl	sp@+,a0
	movl	a0,usp			/* restore user sp */
	INC	(V_SYSCALL)
	jra	iret

SCBVEC(trap2):	SIG_CLEAN_SYSCALL(B,7)	/* trampoline format B, syscall -7 */
SCBVEC(trap3):	SIG_CLEAN_SYSCALL(A,6)	/* trampoline format A, syscall -6 */
SCBVEC(trap4):	SIG_CLEAN_SYSCALL(9,5)	/* trampoline format 9, syscall -5 */
SCBVEC(trap5):	SIG_CLEAN_SYSCALL(8,4)	/* trampoline format 8, syscall -4 */
SCBVEC(trap6):	SIG_CLEAN_SYSCALL(2,3)	/* trampoline format 2, syscall -3 */
SCBVEC(trap8):				/* trampoline format 0, syscall -2 */
	PEEXT(T_SYSCALL + (-2 << 16)); jra	2b
SCBVEC(trap7):				/* longjmp cleanup, syscall -1 */
	PEEXT(T_SYSCALL + (-1 << 16)); jra	2b

/************************************************************************/

	.globl	_badaddr
/*
 * badaddr(addr, len)
 *	See if access addr with a len type instruction causes a bus or address 
 *	error. Len is length of access (1=byte, 2=short, 4=long).
 */
_badaddr:
	movl	sp@(4),a0		/* address to be tested */
	movl	sp@(8),d1		/* size of operand (1, 2, or 4) */
	movw	sr,d0
	movl	d0,a1			/* save old sr in a1 */
	movl	#0,d0			/* hopeful return value: 0 */
	orw	#PSL_HIGH,sr		/* disable interrupts */
	movl	0+SCB_BUSERR,sp@-	/* save old bus error vector */
	movl	0+SCB_ADRERR,sp@-	/* save old address error vector */
	movl	#8f,0+SCB_BUSERR	/* set new bus error vector */
	movl	#9f,0+SCB_ADRERR	/* set new address error vector */
	tstl	d1
	jle	3f			/* READ operation */
	lsrw	#1,d1			/* byte operation? */
	jcc	1f			/*   no */
	tstb	a0@			/*   yes -- try to access byte */
    1:	lsrw	#1,d1			/* short operation? */
	jcc	2f			/*   no */
	tstw	a0@			/*   yes -- try to access short */
    2:	lsrw	#1,d1			/* long operation? */
	jcc	4f			/*   no */
	tstl	a0@			/*   yes -- try to access long */
	jra	4f
    3:	negl	d1			/* WRITE operation */
	lsrw	#1,d1			/* byte operation? */
	jcc	1f			/*   no */
	movb	d0,a0@			/*   yes -- try to access byte */
    1:	lsrw	#1,d1			/* short operation? */
	jcc	2f			/*   no */
	movw	d0,a0@			/*   yes -- try to access short */
    2:	lsrw	#1,d1			/* long operation? */
	jcc	4f			/*   no */
	movl	d0,a0@			/*   yes -- try to access long */
    4:	movl	sp@+,0+SCB_ADRERR	/* restore old address error vector */
	movl	sp@+,0+SCB_BUSERR	/* restore old bus error vector */
	movl	a1,d1
	movw	d1,sr			/* restore old interrupt priority */
	rts				/* return value in d0 */

    8:	addw	#1,d0			/* BUS ERROR modify return value */
	andw	#ESF_SSW_20_SOFTMSK,sp@(ESF_SSW)
	jra	dorte			/* return from bus error exception */

    9:	addw	#8,d0			/* ADDRESS ERROR modify return value */
	andw	#ESF_SSW_20_SOFTMSK,sp@(ESF_SSW)
	jra	dorte			/* return from address error exceptn */

/* addupc(pc, &u.u_prof, nticks)
/*	struct uprof {			/* profile arguments */
/*		short	*pr_base;	/* buffer base */
/*		unsigned pr_size;	/* buffer size */
/*		unsigned pr_off;	/* pc offset */
/*		unsigned pr_scale;	/* pc scaling */
/*	} u_prof;
/* */
	.globl	_addupc
_addupc:movl	sp@(8),a1		/* &u.u_prof */
	movl	sp@(4),d0
	subl	a1@(8),d0		/* corrected pc */
	jlt	9f
	lsrl	#1,d0			/* logical right shift */
	movl	a1@(12),d1
	lsrl	#1,d1			/* ditto for scale */
	mulul	d1, d1:d0		/* [d1:d0]=(pc-pr_off)/2*pr_scale/2 */
	lsll	#1,d0			/* quad right shift 14 */
	roxll	#1,d1
	jcs	9f
	lsll	#1,d0
	roxll	#1,d1
	jcs	9f
	movw	d1,d0
	clrw	d1
	swap	d0
	swap	d1
	jne	9f
	andw	#0xFFFE,d0
	cmpl	a1@(4),d0		/* length */
	jhs	9f
	addl	a1@,d0			/* base */
	movl	d0,a0
	movl	_nofault,sp@-
	movl	#8f,_nofault
	movsw	a0@,d1
	addl	sp@(16),d1
	movsw	d1,a0@
    7:	movl	sp@+,_nofault
    9:	rts
    8:	clrl	a1@(12)
	jra	7b

	.globl	_useracc
	.globl	_kernacc
_useracc:
#ifdef	TRFS
	tstl	_u+U_TCLIENT
	jne	_Tuseracc
#endif	TRFS
	movl	sp@(4),d0		/* user virtual address */
	movl	d0,d1			/* upper address must be zero */
	andl	#~NONT_MASK,d1
	jeq	1f
    	movl	#0,d0
	rts
    1:	andl	#NONT_MASK,d0
	orl	#USRV_BASE,d0		/* user source address */
	movl	d0,a0
	jra	1f

_kernacc:
	movl	sp@(4),a0		/* system virtual address */
    1:	movl	#NBPG,d1
	movl	a0,a1
	addl	sp@(8),a1
	subl	#1,a1			/* address of last byte */
	movl	_nofault,sp@-
	movl	#4f,_nofault
	tstl	sp@(16)			/* 1 => READ */
	jeq	2f

    1:	movb	a0@,d0			/* check for read access */
	addl	d1,a0
	cmpl	a0,a1
	jgt	1b
	movb	a1@,d0
	jra	3f

    2:	movb	a0@,d0			/* check for write access */
	movb	d0,a0@
	addl	d1,a0
	cmpl	a0,a1
	jgt	2b
	movb	a1@,d0
	movb	d0,a1@

    3:	movl	#1,d0
    1:	movl	sp@+,_nofault
	rts
    4:	movl	#0,d0
	jra	1b

	.globl	_noproc
	.comm	_noproc,4
	.globl	_runrun
	.comm	_runrun,4
	.globl	_setrq
	.globl	_remrq
	.globl	__insque
	.globl	__remque
/*
 * setrq(p): 	Called at spl6().  p->p_stat should be SRUN.
 */
_setrq:	movl	sp@(4),a0
	tstl	a0@(P_RLINK)
	jeq	1f
	pea	panic_setrq
	jsr	_panic

    1:	movl	#0,d1
	movb	a0@(P_PRI),d1
	lsrw	#2,d1			/* put on queue which is p->p_pri / 4 */
	movl	d1,d0
	lslw	#3,d0
	lea	_qs,a1
	lea	a1@(0,d0:w),a1
	movl	a1,a0@			/* insert at end of queue */
	movl	a1@(4),d0
	movl	d0,a0@(4)
	movl	a0,a1@(4)
	movl	d0,a1
	movl	a0,a1@
	lea	_whichqs,a1		/* mark queue non-empty */
	movl	a1@,d0
	bset	d1,d0
	movl	d0,a1@
	rts

/*
 * remrq(p): 	Called at spl6().
 */
_remrq:	movl	sp@(4),a0
	movl	#0,d1
	movb	a0@(P_PRI),d1
	lsrw	#2,d1
	movl	_whichqs,d0
	bclr	d1,d0
	jne	1f
	movl	d0,_whichqs
	pea	panic_remrq
	jsr	_panic

    1:	movl	a0@,a1
	movl	a0@(4),d1
	cmpl	d1,a1
	jne	1f
	movl	d0,_whichqs
    1:	movl	d1,a1@(4)
	exg	d1,a1
	movl	d1,a1@
	clrl	a0@(P_RLINK)
	rts

__insque:
	movw	sr,d1
	orw	#PSL_HIGH,sr
	movl	sp@(4),a0		/* new */
	movl	sp@(8),a1		/* pred */
	movl	a1@,d0			/* succ */
	movl	d0,a0@
	movl	a1,a0@(4)
	movl	a0,a1@
	movl	d0,a1
	movl	a0,a1@(4)
	movw	d1,sr
	rts

__remque:
	movw	sr,d1
	orw	#PSL_HIGH,sr
	movl	sp@(4),a0
	movl	a0@,a1
	movl	a0@(4),d0
	movl	d0,a1@(4)
	exg	d0,a0
	movl	a1,a0@
	movw	d1,sr
	rts

	.globl	_swtch
	.globl	_waitloc
/*
 * swtch: switch to another process.
 */
_swtch:	movw	sr,_u+PCB_PSL+2
	movl	#1,_noproc
	clrl	_runrun

	/* determine highst priority nonempty queue */
    1:	orw	#PSL_HIGH,sr		/* disable interrupts */
	movl	_whichqs,d0
	movl	#0,d1
	jra	3f
    2:	addw	#1,d1
    3:	lsrl	#1,d0			/* find an active queue */
	jcs	4f			/* jump if active */
	jne	2b

	bclr	#AST_SOFT,_ast		/* no active queue, check ast's */
	jne	2f
	bclr	#AST_TIC,_ast
	jne	3f
	stop	#PSL_IPL0		/* no ast's, go idle */

_waitloc:
	jra	1b			/* try again */

    2:	movw	#PSL_IPLS,sr		/* service software ASTs */
	jsr	_softint
	jra	1b

    3:	movw	#PSL_IPLC,sr		/* service clock ast */
	movl	#PSL_IPL0,sp@-
	pea	_waitloc		/* push pc (idle address) */
	jsr	_softclock		/* softclock(pc,psl) */
	addl	#8,sp
	jra	1b

	/* found nonempty run queue, remove first entry */
    4:	movw	d1,d0
	lslw	#3,d0
	lea	_qs,a1
	lea	a1@(0,d0:w),a1		/* a1 -> queue header */
	movl	a1@,a0			/* a0 -> first entry in queue */
	cmpl	a1,a0			/* make sure queue not empty */
	jne	1f
    2:	pea	panic_swtch
	jsr	_panic

    1:	movl	a0@,d0			/* unlink item from queue */
	movl	d0,a1@			/* unlink from queue header */
	exg	d0,a1
	movl	d0,a1@(4)		/* unlink from successor */
	cmpl	d0,a1			/* if queue is now empty, */
	jne	1f
	movl	_whichqs,d0		/* mark queue empty */
	bclr	d1,d0
	movl	d0,_whichqs

    1:	clrl	_noproc
	tstl	a0@(P_WCHAN)
	jne	2b
	cmpb	#SRUN,a0@(P_STAT)
	jne	2b
	clrl	a0@(P_RLINK)
	movl	a0@(P_ADDR),a1
	movl	a1@,_masterpaddr
	INC	(V_SWTCH)

	movml	#<d2-d7,a2-a7>,_u	/* save 68020 registers */
	tstb	_ctx			/* if context is system context */
	jeq	6f			/* dont save floating point state */

#ifdef	FP_68881
	.globl	_save_68881
	.globl	_restore_68881
_save_68881:
	tstb	_have_68881		/* if we have 68881 chip, save state */
	jeq	1f
	lea	_u+U_68881_STATE,a2
	fsave	a2@			/* save state frame */
	tstb	a2@			/* if null, dont save registers */
	beq	1f
	lea	_u+U_68881_REGS,a2
	fmovemx	#<f0-f7>,a2@		/* save programmers model */
	addl	#8*12,a2
	fmoveml	#<fpcr,fpsr,fpiar>,a2@
    1:
#endif	FP_68881
#ifdef	FP_SKY
	.globl	_save_sky
	.globl	_restore_sky
_save_sky:
	movl	_skybase,d2		/* SKY FPP save context */
	jeq	5f
	movl	d2,a3
	tstb	a0@(P_FLAG)		/* high bit of p_flag is sky map bit */
	jge	5f
	movw	a3@(SKYSTC),d2
	andw	#SKYMODE,d2
	cmpw	#SKYMODE_RUN,d2		/* dont save if mode not Run Enable */
	jne	5f
	lea	_u+U_SKY,a4
    1:	movw	a3@(SKYSTC),d2
	btst	#SKYIDLE,d2
	jeq	2f
	movw	#0x1063,a4@+		/* noop */
	jra	4f
    2:	btst	#SKYRDY,d2
	jeq	1b
	movw	#SKYMODE_SS,a3@(SKYSTC)	/* set single step mode */
    1:	movw	a3@(SKYSTC),d2
	btst	#SKYDIR,d2
	jeq	2f
	movw	a3@(SKYDT1),d2
	jra	3f
    2:	movw	d2,a3@(SKYDT1)
    3:	movw	a3@(SKYSTC),d2
	btst	#SKYRDY,d2
	jne	1b
    	movw	a3@(SKYCOM),d2
	subw	#1,d2
	movw	d2,a4@+
    	movw	#SKYRESET,a3@(SKYSTC)	/* set reset bit */
	movw	#0x1000,a3@(SKYCOM)	/* initialize */
	movw	#0x1000,a3@(SKYCOM)	/* initialize */
	movw	#0x1001,a3@(SKYCOM)	/* sp_r add */
	movw	#SKYMODE_RUN,a3@(SKYSTC)
    4:	movw	#0x1063,a3@(SKYCOM)	/* noop */
    	movw	#0x1040,a3@(SKYCOM)	/* context save */
	lea	a3@(SKYDT1),a3
	movl	#8-1,d2
    1:	movl	a3@,a4@+
	dbra	d2,1b
    5:
#endif	FP_SKY

    6:	movb	a0@(P_CONTEXT),d1	/* get new context */
	jeq	2f			/* jump if system context */

    	movl	#0,d2			/* update vc_lastaccess for lru */
	movb	d1,d2			/* context allocation scheme */
	lslw	#3,d2
	movl	_vc_tick,d3
	addl	#1,d3
	movl	d3,_vc_tick
	lea	_vc_context,a2
	movl	d3,a2@(0,d2:w)

	movl	#TBUF_INVALID,d3
	movl	#TBUF_INCR,d4
	lea	TBUF_BASE_USR,a2	/* Invalidate user TBUF */
    	movl	#(NTBUFS/4)-1,d2
    1:	movl	d3,a2@;		addl	d4,a2
	movl	d3,a2@;		addl	d4,a2
	movl	d3,a2@;		addl	d4,a2
	movl	d3,a2@;		addl	d4,a2
	dbra	d2,1b

    2:	movl	#(CCACHE_CLEAR|CCACHE_ENABLE),d2
	movec	d2,cac			/* Invalidate 020 cache */
	movb	d1,_ctx
#ifndef	M68025
	orb	_ctx_bits,d1		/* preserve clock and parity */
#endif	M68025
	movb	d1,CTX			/* set new context */

/* 
 * NOTE: M68020: If a level 7 interrupt gets acknoldged between the next two 
 * instructions the system may hang/crash/wierd-out!! CTH
 * Also, dont reference uarea in level 7 interrupt handler!
 */
	lea	SCRATCH_STACK,sp	/* KLUDGE tmp stack, for NMI's! */
	lea	_Umap,a2		/* MAP NEW U AREA */
	lea	_TBUF_S_u,a3
	movw	#UPAGES-1,d1
	movl	#TBUF_INCR,d2

    1:  movl	a1@+,d0			/* get pte */
	andl	#~PG_PROT,d0		/* remove users _u area protection */
	orl	#PG_V|PG_KW|PG_CACHEK,d0 /* kernel can write the _u area */
	movl	d0,a2@+			/* map new _u area */
	clrl	a3@			/* invalidate old _u area translation */
	addl	d2,a3
	dbra	d1,1b

   	movml	_u,#<d2-d7,a2-a7>	/* restore 68020 registers */
#ifdef	KPROF
	tstb	_kprof_enable+3
	jeq	1f
	addl	#1,_kprof_swtch		/* kprof: count context switches */
    1:
#endif	KPROF
	tstb	_ctx			/* if new context is system context, */
	jeq	3f			/* dont restore floating point state */

#ifdef	FP_68881
_restore_68881:
	tstb	_have_68881		/* if we have a 68881, restore state */
	jeq	2f
	lea	_u+U_68881_STATE,a0
	tstb	a0@			/* skip if no saved model */
	jeq	1f
	lea	_u+U_68881_REGS,a1
	fmovemx	a1@,#<f0-f7>
	addl	#8*12,a1
	fmoveml	a1@,#<fpcr,fpsr,fpiar>	/* restore programers model */
    1:	frestore	a0@		/* restore state frame */
    2:
#endif	FP_68881
#ifdef	FP_SKY
_restore_sky:
	movl	_skybase,d0
	jeq	2f
	movl	d0,a0
	movl	_u+U_PROCP,a1		/* u.u_procp */
	tstb	a1@(P_FLAG)		/* high bit of p_flag is sky map bit */
	jge	2f
	movw	a0@(SKYSTC),d0
	andw	#SKYMODE,d0
	cmpw	#SKYMODE_RUN,d0
	jne	2f
	movw	#0x1041,a0@(SKYCOM)	/* context restore */
	lea	_u+U_SKY,a1
	movw	a1@+,d0
	movl	#8-1,d1
    1:	movl	a1@+,a0@(SKYDT1)
	dbra	d1,1b
    	movw	d0,a0@(SKYCOM);
    2:
#endif	FP_SKY

    3:	movl	_u+PCB_SSWAP,d0
	jeq	1f
	clrl	_u+PCB_SSWAP
	movl	d0,sp@
	movw	_u+PCB_PSL+2,sr
	jsr	_longjmp

    1:	movl	#0,d1
	movw	_u+PCB_PSL+2,d1
	jra	splx

	.globl	_setjmp
	.globl	_longjmp
	.globl	_resume
/*
 * Non-local goto's
 */
_setjmp:movl	sp@+,a1			/* return address */
	movl	sp@,a0			/* jmpbuf */
	movml	#<d2-d7,a2-a7>,a0@
	movl	a1,a0@(12*4)		/* return pc */
	movl	#0,d0			/* zero return value */
	jmp	a1@			/* return */

_longjmp:
	movl	sp@(4),a0		/* jmpbuf */
	movl	a6,d0			/* save fp in case we panic */
	movml	a0@+,#<d2-d7,a2-a6>
	movl	a0@+,a1			/* to be new sp */
	cmpl	sp,a1			/* must be a pop */
	jge	1f
	movl	d0,a6			/* put frame pointer back */
	link	a6,#0			/* for stack backtrace */
	pea	panic_ljmp
	jsr	_panic			/* no return */

    1:	movl	a1,sp
	movl	a0@,a1			/* return pc */
	movl	a0,d0			/* nonzero return value */
	jmp	a1@			/* return */

_resume:movw	sr,_u+PCB_PSL+2
	movml	#<d2-d7,a2-a7>,_u
	rts

	.globl	_setsoftclock
_setsoftclock:
	movw	sr,d0
	andw	#PSL_HIGH,d0		/* are we running at low priority? */
	jeq	1f
	bset	#AST_TIC,_ast		/*   no -- set ast pending & return */
	rts

    1:	movw	#PSL_IPLC,sr
	pea	PSL_IPL0
	movl	sp@(4),sp@-
	jsr	_softclock		/* softclock(pc,psl) */
	addl	#8,sp
	movw	#PSL_IPL0,sr
	rts

/* set software ast interrupt pending, must be called at splhigh! */
	.globl	_siron
_siron:	bset	#AST_SOFT,_ast
	rts

	.globl	_splx
	.globl	_spl
	.globl	_spl0
	.globl	_spl1
	.globl	_splsoftclock
	.globl	_splsoft
	.globl	_splnet			/* dont go lower than current ??? */
	.globl	_spl4
	.globl	_spl5
	.globl	_spltty
	.globl	_splimp			/* dont go lower than current ??? */
	.globl	_spl6
	.globl	_spl7
	.globl	_splhigh
	.globl	_splclock
	.globl	_splbio

_splx:	movl	sp@(4),d1
splx:	movw	d1,d0
	andw	#PSL_HIGH,d0
	jeq	_spl0
	clrl	d0
	movw	sr,d0
	movw	d1,sr
	rts

_spl:	clrl	d0
	movw	sr,d0
	rts

_spl0:	clrl	d0
	movw	sr,d0
    1:	movw	#PSL_IPL7,sr		/* raise priority to protect ast */
	tstb	_ast
	jeq	2f
	bclr	#AST_SOFT,_ast
	jne	3f
	bclr	#AST_TIC,_ast
	jne	4f
    2:	andw	#PSL_LOW,sr		/* drop to low priority */
	rts

    3:	movw	#PSL_IPLS,sr		/* service software ASTs */
	jsr	_softint
	jra	1b

    4:	movw	#PSL_IPLC,sr
	movl	d0,sp@-			/* save previous sr */
	pea	PSL_CURMOD
	movl	sp@(8),sp@-		/* push pc (return address) */
	jsr	_softclock		/* softclock(pc,psl) */
	addl	#8,sp
	movl	sp@+,d0			/* return value */
	jra	1b

_splnet:clrl	d0
	movw	sr,d0
	movw	#PSL_IPLN,sr
	rts

_splsoft:
	clrl	d0
	movw	sr,d0
	movw	#PSL_IPLS,sr
	rts

_splsoftclock:
	clrl	d0
	movw	sr,d0
	movw	#PSL_IPLC,sr
	rts

_spl1:	clrl	d0
	movw	sr,d0
	movw	#PSL_IPL1,sr
	rts

_spl4:	clrl	d0
	movw	sr,d0
	movw	#PSL_IPL4,sr
	rts

_spltty:
_spl5:	clrl	d0
	movw	sr,d0
	movw	#PSL_IPL5,sr
	rts

_splclock:
_splbio:
_splimp:
_spl6:	clrl	d0
	movw	sr,d0
	movw	#PSL_IPL6,sr
	rts

_splhigh:
_spl7:	clrl	d0
	movw	sr,d0
	orw	#PSL_HIGH,sr
	rts

	.globl	_pcopyin
	.globl	_pcopyout
	.globl	_pcopy
	.globl	_copyin
	.globl	_copyout
	.globl	_copyinstr
	.globl	_copyoutstr
	.globl	_copystr
	.globl	_fubyte
	.globl	_fuibyte
	.globl	_fuword
	.globl	_fuiword
	.globl	_subyte
	.globl	_suibyte
	.globl	_suword
	.globl	_suiword
_pcopyin:				/* pcopyin(ps, kd, bcount) */
_pcopyout:				/* pcopyout(ks, pd, bcount) */
_pcopy:					/* pcopy(ps, pd, bcount) */
	jmp	_bcopy

_copyin:				/* copyin(us, kd, bcount) */
#ifdef	TRFS
	tstl	_u+U_TCLIENT
	jne	_Tcopyin
#endif	TRFS
	movl	sp@(4),d0		/* user virtual */
	movl	d0,d1			/* upper address must be zero */
	andl	#~NONT_MASK,d1
	jne	6f
	andl	#NONT_MASK,d0
	orl	#USRV_BASE,d0		/* user source */
	movl	d0,a0
	movl	sp@(8),a1		/* kernel destination */
	movw	a1,d1
	jra	1f

_copyout:				/* copyout(ks, ud, bcount) */
#ifdef	TRFS
	tstl	_u+U_TCLIENT
	jne	_Tcopyout
#endif	TRFS
	movl	sp@(8),d1		/* user virtual */
	movl	d1,d0			/* upper address must be zero */
	andl	#~NONT_MASK,d0
	jne	6f
	andl	#NONT_MASK,d1
	orl	#USRV_BASE,d1		/* user destination */
	movl	d1,a1
	movl	sp@(4),a0		/* kernel source */
	movw	a0,d0			/* fall through ... */

    1:	eorw	d1,d0			/* common copyin/copyout code */
	movl	sp@(12),d1		/* byte count */
	jle	4f
	movl	_nofault,sp@-
	movl	#5f,_nofault
	lsrw	#1,d0
	jcs	3f
	movw	a0,d0			/* check for both addrs odd */
	lsrw	#1,d0
	jcc	1f
	movb	a0@+,a1@+
	subl	#1,d1
    1:	movl	d1,d0
	lsrl	#5,d0
	andl	#0x1F,d1
	jra	2f
    1:	movl	a0@+,a1@+; movl	a0@+,a1@+; movl	a0@+,a1@+; movl	a0@+,a1@+;
	movl	a0@+,a1@+; movl	a0@+,a1@+; movl	a0@+,a1@+; movl	a0@+,a1@+;
    2:	dbra	d0,1b
	addw	#1,d0
	subl	#1,d0
	jge	1b
	movw	d1,d0
	lsrw	#1,d0
	andw	#1,d1
	jra	2f
    1:	movw	a0@+,a1@+
    2:	dbra	d0,1b
	jra	3f
    1:	movb	a0@+,a1@+
    3:	dbra	d1,1b
	addw	#1,d1
	subl	#1,d1
	jge	1b
	movl	sp@+,_nofault
    4:	movl	#0,d0
	rts
    5:	movl	sp@+,_nofault
    6:	movl	#EFAULT,d0
	rts

/* bzero user address space */
	.globl	_u_bzero
_u_bzero:				/* u_bzero(us, bcount) */
	movl	sp@(4),d0		/* user virtual */
	movl	d0,d1			/* make shure upper address is zero */
	andl	#~NONT_MASK,d1
	jne	6f
	andl	#NONT_MASK,d0
	orl	#USRV_BASE,d0		/* user source */
	movl	d0,a0
	movl	sp@(8),d1		/* byte count */
	jle	4f
	movl	_nofault,sp@-
	movl	#5f,_nofault
    	movl	d1,d0
	lsrw	#1,d0
	jcc	1f
	clrb	a0@+
	subl	#1,d1
    1:	movl	d1,d0
	lsrl	#5,d0
	andl	#0x1F,d1
	jra	2f
    1:	clrl	a0@+; clrl a0@+; clrl a0@+; clrl a0@+;
	clrl	a0@+; clrl a0@+; clrl a0@+; clrl a0@+;
    2:	dbra	d0,1b
	addw	#1,d0
	subl	#1,d0
	jge	1b
	movl	d1,d0
	lsrw	#1,d0
	jra	2f
    1:	clrw	a0@+
    2:	dbra	d0,1b
	andw	#1,d1
	jeq	3f
	clrb	a0@+
    3:	movl	sp@+,_nofault
    4:	movl	#0,d0
	rts
    5:	movl	sp@+,_nofault
    6:	movl	#EFAULT,d0
	rts


_copyinstr:				/* copyinstr(us, kd, maxlen, &len) */
#ifdef	TRFS
	tstl	_u+U_TCLIENT
	jne	_Tcopyinstr
#endif	TRFS
	movl	sp@(4),d0		/* user virtual */
	movl	d0,d1			/* make shure upper address is zero */
	andl	#~NONT_MASK,d1
	jne	5f
	andl	#NONT_MASK,d0
	orl	#USRV_BASE,d0		/* user source */
	movl	d0,a0
	movl	sp@(8),a1		/* kernel destination */
	jra	1f

_copyoutstr:				/* copyoutstr(ks, ud, maxlen, &len) */
#ifdef	TRFS
	tstl	_u+U_TCLIENT
	jne	_Tcopyoutstr
#endif	TRFS
	movl	sp@(4),a0		/* kernel source */
	movl	sp@(8),d0		/* user virtual */
	movl	d0,d1			/* make shure upper address is zero */
	andl	#~NONT_MASK,d1
	jne	5f
	andl	#NONT_MASK,d0
	orl	#USRV_BASE,d0		/* user destination */
	movl	d0,a1			/* fall through ... */
	jra	1f

_copystr:				/* copystr(ks, kd, maxlen, &len) */
	movl	sp@(4),a0		/* kernel source */
	movl	sp@(8),a1		/* kernel destination */

    1:	clrl	d0			/* found null return code*/
	movl	sp@(12),d1		/* get max len copied */
	subl	#1,d1
	jlt	3f
    	movl	_nofault,sp@-
	movl	#4f,_nofault
    1:	movb	a0@+,a1@+
	jeq	2f
    	dbra	d1,1b
	addw	#1,d1
	subl	#1,d1
	jge	1b
	addl	#1,d1
	movl	#ENOENT,d0		/* no null return code*/
    2:	movl	sp@+,_nofault
    3:	movl	sp@(16),a0		/* &lencopied */
	cmpl	#0,a0
	jeq	1f			/* skip if NULL */
	subl	sp@(12),d1
	negl	d1
	movl	d1,a0@			/* set lencopied */
    1:	rts
    4:	movl	#EFAULT,d0		/* illegal address return code*/
	jra	2b
    5:	movl	#EFAULT,d0
	rts

_fubyte:
_fuibyte:
#ifdef	TRFS
	tstl	_u+U_TCLIENT
	jne	_Tfubyte
#endif	TRFS
	movl	sp@(4),a0
	movl	_nofault,sp@-
	movl	#1f,_nofault
	clrl	d0
	movsb	a0@,d0
	movl	sp@+,_nofault
	rts

_fuword:
_fuiword:
#ifdef	TRFS
	tstl	_u+U_TCLIENT
	jne	_Tfuword
#endif	TRFS
	movl	sp@(4),a0
	movl	_nofault,sp@-
	movl	#1f,_nofault
	movsl	a0@,d0
	movl	sp@+,_nofault
	rts

_subyte:
_suibyte:
#ifdef	TRFS
	tstl	_u+U_TCLIENT
	jne	_Tsubyte
#endif	TRFS
	movl	sp@(4),a0
	movl	sp@(8),d0
	movl	_nofault,sp@-
	movl	#1f,_nofault
	movsb	d0,a0@
	clrl	d0
	movl	sp@+,_nofault
	rts

_suword:
_suiword:
#ifdef	TRFS
	tstl	_u+U_TCLIENT
	jne	_Tsuword
#endif	TRFS
	movl	sp@(4),a0
	movl	sp@(8),d0
	movl	_nofault,sp@-
	movl	#1f,_nofault
	movsl	d0,a0@
	clrl	d0
	movl	sp@+,_nofault
	rts
    1:	movl	#-1,d0
	movl	sp@+,_nofault
	rts

	.globl	_copyseg
	.globl	_clearseg
_copyseg:
	movl	sp@(8),d0		/* page frame number */
	movl	#PGSHIFT,d1
	asll	d1,d0
	movl	d0,a1			/* non translated address destination */
	movl	sp@(4),d0		/* user virtual */
	movl	d0,d1			/* make shure upper address is zero */
	andl	#~NONT_MASK,d1
	jeq	1f
	pea	panic_copyseg
	jsr	_panic
    1:	andl	#NONT_MASK,d0
	orl	#USRV_BASE,d0		/* user virtual space */
	movl	d0,a0
	movw	#(NBPG>>5)-1,d0		/* 8 longs (32 bytes) per loop */
    1:	movl	a0@+,a1@+; movl	a0@+,a1@+; movl	a0@+,a1@+; movl	a0@+,a1@+;
	movl	a0@+,a1@+; movl	a0@+,a1@+; movl	a0@+,a1@+; movl	a0@+,a1@+;
	dbra	d0,1b
	movl	#0,d0
	rts

_clearseg:
	movl	sp@(4),d0		/* page frame number */
	movl	#PGSHIFT,d1
	asll	d1,d0
	movl	d0,a0			/* non translated address */
	movl	#0,d0			/* return value too */
	movw	#(NBPG>>5)-1,d1		/* 8 longs (32 bytes) per loop */
    1:	movl	d0,a0@+; movl	d0,a0@+; movl	d0,a0@+; movl	d0,a0@+;
	movl	d0,a0@+; movl	d0,a0@+; movl	d0,a0@+; movl	d0,a0@+;
	dbra	d1,1b
	rts

	.globl	_getmeml
_getmeml:
	movl	sp@(4),d0		/* physical address */
	andl	#NONT_MASK,d0		/* non-translated */
	movl	d0,a0
	movl	a0@,d0
	rts

	.globl	_putmeml
_putmeml:
	movl	sp@(4),d0		/* physical address */
	andl	#NONT_MASK,d0		/* non-translated */
	movl	d0,a0
	movl	sp@(8+4),a0@
	rts

	.globl	_blkclr
	.globl	_ovbcopy
_blkclr: jmp	_bzero
_ovbcopy:jmp	_bcopy

	.globl	_doadump
_doadump:
	link	a6,#0
	movml	#<d2-d7,a2-a7>,_u	/* update pcb for running process */
	jsr	_dumpsys
	unlk	a6
	rts

	.globl	__reboot
__reboot:
	movl	_howto,d7
	movl	_devtype,d6
#ifdef	M68025
	movb	#BSR_W_MOTCACHE,d0
	movb	d0,BSR
#endif	M68025
	jmp	PROM_REBOOT

	.globl	_parityon
_parityon:
#ifdef	M68025
	movb	_bsr,d0
	orb	#BSR_W_PARITY,d0
	movb	d0,_bsr
	movb	d0,BSR
#else	M68025
	movb	_ctx_bits,d0
	orb	#CTX_PARITY,d0
	movb	d0,_ctx_bits
	orb	_ctx,d0
	movb	d0,CTX
#endif	M68025
	rts

	.globl	_parityoff
_parityoff:
#ifdef	M68025
	movb	_bsr,d0
	andb	#~BSR_W_PARITY,d0
	movb	d0,_bsr
	movb	d0,BSR
#else	M68025
	movb	_ctx_bits,d0
	andb	#~CTX_PARITY,d0
	movb	d0,_ctx_bits
	orb	_ctx,d0
	movb	d0,CTX
#endif	M68025
	rts

	.globl	_cacheon
	.globl	_cacheclear
_cacheon:
_cacheclear:
	movl	#CCACHE_CLEAR|CCACHE_ENABLE,d0
	movec	d0,cac
	rts

	.globl	_cacheoff
_cacheoff:
	movl	#CCACHE_CLEAR,d0
	movec	d0,cac
	rts

	/*
	 * Test-and-set primative. Sets the high-order bit of the 
	 * pointed-to byte. Returns zero (failure) if the byte had 
	 * been nonzero, else 1 (success). Routine is indivisible even 
	 * in multi-processor environment IF the byte is in VME memory.
	 */
	.globl	_tas
_tas:	movl	#0,d0
	movl	sp@(4),a0
	tas	a0@
	jne	1f
	addw	#1,d0
   1:	rts

	.globl	_have68881
	/* 
	 * Determine if 68881 coprocessor present.
	 *   o	Rev A1 boards: FPCS* tied to FPSCAK[01]* causes proto vio
	 *   o	Later boards use jumper E33 and cause bus errors (which)the 
	 *	68020 turns into F-line emulation traps.
	 */
_have68881:
	clrl	d0
#ifdef	FP_68881
	movl	0+SCB_EM1111,a0		/* reprogram vectors */
	movl	0+SCB_COPROC,a1
	movl	sp,d1
	movl	#1f,0+SCB_EM1111
	movl	#1f,0+SCB_COPROC
	fnop
	movl	#-1,d0
    1:	movl	a0,0+SCB_EM1111
	movl	a1,0+SCB_COPROC
	movl	d1,sp
#endif	FP_68881
	movb	d0,_have_68881
	rts

	.globl	_byterev
_byterev:
	movl	sp@(4),a0		/* address of byte string */
	movl	a0,a1
	movl	sp@(8),d1		/* length of string */
	addl	#1,d1
	lsrl	#1,d1
	jra	2f
    1:	movw	a1@,d0
	rolw	#8,d0
	movw	d0,a1@+
    2:	dbra	d1,1b
	addw	#1,d1
	subl	#1,d1
	jge	1b
	movl	a1,d0
	rts

/*
 * cksum(sum, string, len, sumlen)
 *  	return 16bit one's complement sum of 'sum' and the 16bit one's 
 *	complement sum of the string 'string' of byte length 'len'.
 *	Complicated by 'len' or 'sumlen' not being even.
 */ 
	.globl	_cksum
_cksum:	movl	d2,sp@-			/* save d2 */
	movl	sp@(8),d0		/* sum */
	movl	sp@(12),a0		/* address of byte string */
	movl	a0,d2
	tstl	sp@(16)			/* length of string */
	jeq	9f			/* zero length string, return */
	andb	#0xF,cc			/* X clerar x bit */
	btst	#0,sp@(20+3)		/* swap bytes ?? */
	jne	4f

	/* sum is word alligned, dont swap bytes */
	btst	#0,d2
	jeq	1f

	/* odd start address, do first byte, and then swap bytes */
	subl	#1,sp@(16)	
	clrl	d2
	movb	a0@+,d2
	rolw	#8,d2
	addw	d2,d0			/* X */
	jra	5f

	/* even address, sum alligned */
    1:	movl	sp@(16),d1
	andb	#0xFE,d1
	rorl	#1,d1
	jra	3f
    2:	movw	a0@+,d2
	addxw	d2,d0			/* X */
    3:	dbra	d1,2b
	btst	#0,sp@(16+3)
	jeq	8f

	/* odd length, take care of last byte */
	clrl	d2
	movb	a0@+,d2
	rolw	#8,d2
	addxw	d2,d0			/* X */
	jra	8f

	/* sum is not word alligned, swap bytes */
    4:	btst	#0,d2
	jeq	5f

	/* odd start address, do first byte, and then dont swap bytes */
	subl	#1,sp@(16)		/* X */
	clrl	d2
	movb	a0@+,d2
	addw	d2,d0			/* X */
	jra	1b

	/* even address, sum misalligned, swap bytes */
    5:	movl	sp@(16),d1
	andb	#0xFE,d1
	rorl	#1,d1
	jra	7f
    6:	movw	a0@+,d2
	rolw	#8,d2
	addxw	d2,d0			/* X */
    7:	dbra	d1,6b
	btst	#0,sp@(16+3)
	jeq	8f

	/* odd length, take care of last byte */
	clrl	d2
	movb	a0@+,d2
	addxw	d2,d0			/* X */

	/* fold in last carry bit */
    8:	clrl	d2
	addxw	d2,d0			/* X */
    9:	movl	sp@+,d2			/* restore d2 */
	rts

/*
 * Do a 16 bit one's complement sum of a given number of words
 * The word pointer may not be odd
 */
	.globl	_ocsum
_ocsum:
	movl	sp@(4),a0	/* get ptr */
	movl	sp@(8),d0	/* get word count */
	tstl	d0
	jeq	4f
	movl	d2,sp@-		/* save a reg */
	movl	d0,d2		/* save the count */
	lsrl	#1,d0		/* make d0 longs */
	movl	#0,d1		/* zero accumulator */
	jra	1f		/* into loop */
				/* run in 68010 loop mode til we get a carry */
    2:	addl	a0@+,d1		/* add in long */
    1:	dbcs	d0,2b		/* continue until carry or done */
	jcc	3f		/* if no carry, we're done */
	addl	#1,d1		/* add in carry */
	jra	1b		/* and go back to test for carry again */
    3:	btst	#0,d2		/* another short? */
	jeq	1f		/* no, go away */
	movl	#0,d0		/* must do unsigned add */
	movw	a0@,d0		/* get the short */
	addl	d0,d1		/* add it in */
	jcc	1f
	addl	#1,d1
				/* Now add in high word to low word as above */
    1:	movl	d1,d0
	lsrl	#8,d0		/* get high word in d0 */
	lsrl	#8,d0		/* and clear high do as well */
	andl	#0xFFFF,d1	/* clear high d1 */
	addw	d1,d0		/* add in just the low word */
	movl	#0,d1		/* doesn't clear x bit */
	addxw	d1,d0		/* add in final carry */
	movl	sp@+,d2		/* restore reg */
    4:	rts			/* all done */

	.globl	_invutbuf
_invutbuf:
	movl	#TBUF_INVALID,d0
	movl	#TBUF_INCR,a1
	movw	#(NTBUFS/4)-1,d1
    	lea	TBUF_BASE_USR,a0
    1:	movl	d0,a0@;		addl	a1,a0
	movl	d0,a0@;		addl	a1,a0
	movl	d0,a0@;		addl	a1,a0
	movl	d0,a0@;		addl	a1,a0
	dbra	d1,1b
	rts

#ifndef	C_newptes
	.globl	_newptes
_newptes:
	movl	sp@(4),a0		/* pointer to pte */
	cmpl	#_eSysmap,a0		/* if in Sysmap */
	jhs	1f			/* invalidate system TBUF */
	cmpl	#_Sysmap,a0		/* else invalidate user TBUF */
	jlo	1f
	lea	TBUF_BASE_SYS,a0
	jra	2f
    1:	lea	TBUF_BASE_USR,a0
    2:	movl	sp@(12),d1		/* get count */
	jeq	3f			/* if zero, return */
	cmpl	#20,d1			/* if we have 20 or less, */
	jle	4f			/* only invalidate those that changed */
	movl	#TBUF_INVALID,d0
	movw	#(NTBUFS/4)-1,d1
	movl	#TBUF_INCR,a1
    1:	movl	d0,a0@;		addl	a1,a0
	movl	d0,a0@;		addl	a1,a0
	movl	d0,a0@;		addl	a1,a0
	movl	d0,a0@;		addl	a1,a0
	dbra	d1,1b
    3:	rts
    4:	movl	sp@(8),d0		/* get virtual page address */
	andl	#PG_PFNUM,d0
	movl	d1,a1
	movl	#PGSHIFT,d1
	lsll	d1,d0
	movl	a1,d1
	andl	#TBUF_INDEX_MASK,d0	/* compute index into tbuf */
	addl	d0,a0			/* compute start tbuf address */
	movl	#TBUF_INVALID,d0
	movl	#TBUF_INCR,a1
	jra	2f
    1:	movl	d0,a0@;		addl	a1,a0
    2:	dbra	d1,1b
	rts
#endif	C_newptes

/************************************************************************/

#define	SIOCONT(cont)	cont*10

SCBVEC(sio):
	IBEG
	addl	#1,_intrcnt+I_SIO
	clrl sp@-;  jsr _sioint;  addl #4,sp
	RTE	(V_INTR)

#ifdef	SIOPDMA
/*
 * SIO pseudo dma routine:
 *	d0 - port number * sizeof(struct pdma)
 */
	.align	1
	.globl	siodma
siodma:	addl	#_sio_pdma,d0
	movl	d0,a1			/* pdma structure base */
	movl	a1@+,a0			/* device register base address */
	movb	#SIOW0_TXPEND,a0@(SIO_CTRL)	/* reset transmit int pending */
	jra	2f
    1:	movl	a1@+,d1			/* p_mem */
	cmpl	a1@+,d1			/* p_end > p_mem ? */
	bhs	4f			/* no, go call sioxint */
	exg	d1,a1
	movb	a1@+,a0@		/* adata = *p_mem++ */
	exg	d1,a1
	movl	d1,a1@(-8)
    2:	movl	d0,a1			/* pdma structure base */
	movl	a1@+,a0			/* device register base address */
	movb	a0@(SIO_CTRL),d1
	andb	#SIOR0_TXRDY,d1
	jne	1b			/* if not TXRDY, all done */
    3:	movl	#SIO0_ADR+SIO_CTRL,a0	/* force to PORTA */
	movb	#SIOW0_RETINT,a0@
	RTE	(V_PDMA)
    4:	movl	d0,sp@-			/* save d0 */
	movl	a1@+,sp@-		/* push tty address as arg */
	movl	a1@,a1			/* get address of interrupt routine */
	jsr	a1@			/* call interrupt routine */
	addl	#4,sp			/* pop arg (tty address) */
	movl	sp@+,d0			/* restore d0 */
	jra	3b
#endif	SIOPDMA

/************************************************************************/
#ifdef	DEBUGGER
	.globl	dbg_excpt
/* debugger exception handler */
dbg_excpt:
	tstl	_enable_debugger	/* Ignore if debugger is disabled */
	jeq	2f
	movl	NMIVEC,_dbg_nmi_sav	/* redirect nmi because of */
	movl	#2f,NMIVEC		/* halt button bounce      */
	movw	#PSL_IPL7,sr		/* mask all interrupts */
	movl	sp,_dbg_ex_frame	/* save frame addr */
	movml	#<d0-d7,a0-a6>,_dbg_reg_sav
	movl	usp,a0			/* save usp */
	movl	a0,_dbg_usp_sav
	movl	sp,_dbg_ssp_sav		/* save ssp */
#ifdef	M68020
	movl	#CCACHE_CLEAR,d0
	movec	d0,cac			/* disable cache */
#endif	M68020
        clrl    d1                      /* adjust stack frame size */
        movb    sp@(ESF_VEC),d1
        lsrw    #4,d1
	lea	3f,a1			/* test for valid format */
	tstb	a1@(0,d1:w)
	jne	1f
	pea	panic_badfmt
	jsr	_panic
    1:	lea	4f,a1			/* pick frame size, given format */
	movb	a1@(0,d1:w),d0
	addl	d0,_dbg_ssp_sav		/* save a7 as usp or ssp */
	movl	_dbg_ssp_sav,_dbg_reg_sav+(15*4)
	btst	#5,sp@
	bne	1f
	movl	_dbg_usp_sav,_dbg_reg_sav+(15*4)
    1:	jsr	_dbg			/* go to debugger */
	movl	_dbg_usp_sav,a0		/* back from debugger */
	movl	a0,usp			/* restore usp */
#ifdef	M68020
	movl	#CCACHE_CLEAR|CCACHE_ENABLE,d0
	movec	d0,cac			/* clear and enable cache */
#endif	M68020
	movml  _dbg_reg_sav,#<d0-d7,a0-a6>
        movl    _dbg_nmi_sav,NMIVEC	/* restore nmi vector */
    2:	rte

/* STACK FORMAT:0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F */
#ifdef	M68010
    3:	.byte	1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0
#else	M68010
    3:	.byte	1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0
#endif	M68010
esf_len:
    4:	.byte	ESF_ISIZE0, ESF_ISIZE1, ESF_ISIZE2, 0, 0, 0, 0, 0
	.byte	ESF_ISIZE8, ESF_ISIZE9, ESF_ISIZEA, ESF_ISIZEB, 0, 0, 0, 0
	.align	1

	.globl _trap15
_trap15:trap	#15
	rts
#endif	DEBUGGER

/******* D A T A ***********************************************************/
	.data
	.align	1

/* icode */
	.globl	_icode
	.globl	_szicode
	.globl	_initflg
	.globl	_initi
icode:	movml	pc@(2f),#<d0-d1,a0-a1>	/* load syscall args into regs */
	trap	#1			/* do execve syscall */
	movl	#1,d1
	movl	#SYS_exit,d0
	trap	#1			/* do exit syscall */
    1:	jra	1b			/* loop here if cannot execute init */

    2:	.long	SYS_execve		/* d0: syscall: SYS_execve */
	.long	5f-icode		/* d1: file: "/etc/init" */
	.long	3f-icode		/* a0: argv: ("init", "-?", NULL) */
	.long	4f-icode		/* a1: envp: (NULL) */
    3:	.long	initi-icode		/* "init" */
	.long	6f-icode		/* "?" -> to m|s|M|S in startup */
    4:	.long	0			/* NULL */
    5:	.ascii	"/etc/"
initi:	.asciz	"init"
	.space	40			/* leave space for longer inits */
    6:	.byte	0x2D			/* '-' */
initflg:.byte	0x3F			/* '?' multi/single/GWS flag */
	.byte	0x00			/* '\0' */
	.align	1
_icode:		.long	icode		/* pointer to icode */
_szicode:	.long	_icode-icode	/* length of icode */
_initflg:	.long	initflg		/* pointer to init flag */
_initi:		.long	initi		/* pointer to first letter of "init" */

/* signal trampoline code */
	.globl	_sigcode
	.globl	_szsigcode
	.align	1
sigcode:
	bras	1f			/* +0:  stack format 0 entry */
	bras	2f			/* +2:  stack format 2 entry */
	bras	3f			/* +4:  stack format 8 entry */
	bras	4f			/* +6:  stack format 9 entry */
	bras	5f			/* +8:  stack format A entry */
	bras	6f			/* +10: stack format B entry */
		/* stack format 0 */
    1:	bsrs	8f			/* save regs and call handler */
    1:	trap	#8			/* restore sig mask and return */
	bras	1b
		/* stack format 2 */
    2:	bsrs	8f			/* save regs and call handler */
    1:	trap	#6			/* restore sig mask and return */
	bras	1b
		/* stack format 8 */
    3:	bsrs	8f			/* save regs and call handler */
    1:	trap	#5			/* restore sig mask and return */
	bras	1b
		/* stack format 9 */
    4:	bsrs	8f			/* save regs and call handler */
    1:	trap	#4			/* restore sig mask and return */
	bras	1b
		/* stack format A */
    5:	bsrs	8f			/* save regs and call handler */
    1:	trap	#3			/* restore sig mask and return */
	bras	1b
		/* stack format B */
    6:	bsrs	8f			/* save regs and call handler */
    1:	trap	#2			/* restore sig mask and return */
	bras	1b
    8:	link	a6,#-16			/* just like a real stack frame */
	movml	#<d0-d1,a0-a1>,a6@(-16)	/* save regs d0-d1, a0-a1 */
	movml	a6@(8),#<d0-d1,a0-a1>	/* get our args and handler ptr */
	movml	#<d0-d1,a0-a1>,sp@-	/* push our args as args to handler */
	jsr	a1@			/* handler(sig, code, psigctx) */
	movml	a6@(-16),#<d0-d1,a0-a1>	/* restore regs */
	unlk	a6			/* just like a real stack frame */
	rtd	#16			/* pop the args we were called with */
	.align	1
_sigcode:	.long	sigcode
_szsigcode:	.long	_sigcode-sigcode


/************************************************************************/
	.globl	_ast
	.globl	_bus
	.globl	_cache_enable
	.globl	_clev_bio
	.globl	_clev_biomax
	.globl	_clev_clock
	.globl	_clev_clockmax
	.globl	_clev_imp
	.globl	_clev_impmax
	.globl	_clev_tty
	.globl	_clev_ttymax
	.globl	_cpu
	.globl	_devtype
	.globl	_have_68881
	.globl	_howto
	.globl	_int_svc
	.globl	_masterpaddr
	.globl	_nofault
	.globl	_upages
	.globl	is68020
	.align	1
_int_svc:	.long	0
_ast:		.byte	0
	.align	1
_cache_enable:	.long	1 /* BSR_W_CACHE */
_cpu:		.long	68020
is68020:	.long	0xFFFFFFFF
_have_68881:	.long	0
_nofault:	.long	0
_howto:		.long	0
_devtype:	.long	0
_masterpaddr:	.long	0
_upages:	.long	UPAGES
_clev_ttymax:	.long	5
_clev_biomax:	.long	6
_clev_impmax:	.long	6
_clev_clockmax:	.long	6
_clev_tty:	.long	2
_clev_bio:	.long	2
_clev_imp:	.long	2
_clev_clock:	.long	6
_bus:		.asciz	"VME"

	.align	1
tictoc:		.word	0
N2C:		.asciz	"0123456789ABCDEF"
panic_ljmp:	.asciz	"longjmp"
panic_setrq:	.asciz	"setrq"
panic_remrq:	.asciz	"remrq"
panic_swtch:	.asciz	"swtch"
panic_iret:	.asciz	"iret"
panic_badfmt:	.asciz	"exception format"
panic_stackovf:	.asciz	"kernel stack overflow"
panic_trap:	.asciz	"trap/syscall patch failed"
panic_copyseg:	.asciz	"copyseg illegal user address"
	.text
