/*
 * Copyright (c) 1982 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)machdep.c	6.26 (Berkeley) 2/23/86
 */

#define STACKTRACE /* */
#define SLEEPTRACE /* */
#define BUFFERTRACE /* */

#include "reg.h"
#include "pte.h"
#include "psl.h"
#include "cpu.h"

#include "param.h"
#include "systm.h"
#include "dir.h"
#include "user.h"
#include "kernel.h"
#include "dnlc.h"
#include "map.h"
#include "vm.h"
#include "proc.h"
#include "buf.h"
#include "reboot.h"
#include "conf.h"
#include "vnode.h"
#include "../ufs/inode.h"
#include "file.h"
#include "text.h"
#include "clist.h"
#include "callout.h"
#include "cmap.h"
#include "mbuf.h"
#include "msgbuf.h"
#include <syslog.h>
#ifdef	QUOTA
#include "../ufs/quota.h"
#endif	QUOTA

#include "frame.h"
#include "trap.h"
#include "board.h"
#include "../is68kdev/qbvar.h"


/*
 * DEVICE SPECIFIC
 */
#include "vb.h"				/* VMEBUS: */
#include "nw.h"				/* VMEBUS: */

#ifdef	VBUS
#ifndef	M68020
int		shortmem;		/* page number where short io begins */
#endif	M68020
#endif	VBUS

int		msgbuf_setup = 0;	/* log buffer initialized */
#ifdef	M68020
#ifdef	M68025
int		cpuspeed = 18;		/* fastest cpu speed 68010@10Mhz == 0*/
#else	M68025
int		cpuspeed = 14;		/* fastest cpu speed 68010@10Mhz == 0*/
#endif	M68025
int		have_68881;
#else	M68020
int		cpuspeed = 1;		/* fastest cpu speed 68010@10Mhz == 0*/
#endif	M68020
int		skybase;
int		bufpages;		/* now initialized in param.o */
int		bufpcnt;		/* now initialized in param.o */
int		detachedmem;
int		stacktrace_depth = 0/*16*/;
int		stacktrace_args = 5;
char 		*strarg();
#ifdef	TRFS
u_int	*Client, *ClientNPROC;
#endif	TRFS

/*
 * Declare these as initialized data so we can patch them.
 */
#ifdef	NBUF
int	nbuf = NBUF;
#else
int	nbuf = 0;
#endif
int	nswbuf 	= 0;
int	howto;			/* d7 == how to boot */
int	devtype;		/* d6 == major of root dev */
char	*initi;			/* filename in /etc/ to "init" */
char	*initflg;		/* pointer to init's single/multi/GWS flag */
char	*gpaddr;		/* ISI: GWS: graphics ? */
int	rdswapsize;		/* size in blocks of diskless/cluster swap */

/*
 * Machine-dependent startup code
 */
startup(firstaddr)
	int firstaddr;
{
	register int unixsize;
	register u_int i;
	register struct pte *pte;
	register caddr_t v;
	int maxbufs;
	extern char etext;
	int fa = firstaddr;

	newptes(Usrptmap, btop(usrpt), 1);

	/* Initialize error message buffer (at end of core). */
	maxmem -= btoc(sizeof (struct msgbuf));
	mapin(msgbufmap, btop(&msgbuf), maxmem, 
		btoc(sizeof (struct msgbuf)), PG_V|PG_KW|PG_CACHE);
	msgbuf_setup = 1;

#ifdef	VBUS
	vbnum = atoi(strarg("VBNUM"));
	skyinit();

	/* Map in graphics memory */
	fa = (firstaddr += 
		GP_initialize(ctob(maxmem+btoc(sizeof (struct msgbuf))), fa));
#ifdef	M68010
	/* Map in short io space.  See locore for shortmem.  */
	mapin(shortiomap, btop(vme_short), shortmem, 16, PG_V|PG_FOD|PG_KW);
#endif	M68010
/*#if	NVB > 0				/* stubed in conf/param.c */
	/* Map in cluster communications memory */
	VB_initialize(ctob(maxmem+btoc(sizeof (struct msgbuf))));
/*#endif /**/
/*#if	NNW > 0				/* stubed in conf/param.c */
	/* Map in NW ethernet node processor memory */
	if (vbnum == 0)
		NW_initialize(ctob(maxmem+btoc(sizeof (struct msgbuf))));
/*#endif /**/
#endif	VBUS

	if (strarg("INIT"))
		strcpy(initi, strarg("INIT"));
	/*
	 * This alows one to do a autoboot on a different kernel.  Try
	 * the following.
	 *  ex(0,0)nemesis:/great_kernel(root=sm0a) howto=0
	 * You get the idea.			Rick McNeal, Nov 23, 1987
	 */
	if (strarg("howto"))
	  atob (strarg("howto"), &howto);
	if (howto & RB_SINGLE)
		*initflg = gpaddr ? 'S' : 's';
	else
		*initflg = gpaddr ? 'M' : 'm';

#ifdef	TRFS
	strcpy(hostname, strarg("HOST"));
	hostnamelen = strlen(hostname);
	strcpy(servername, strarg("SERVER"));
	servernamelen = strlen(servername);
	strcpy(gatewayname, strarg("GATEWAY"));
	gatewaynamelen = strlen(gatewayname);
	diskless = (*servername != 0);

	if (diskless) {
		extern int trfs_no;

		if (*hostname == 0)
			panic("host not specified at boottime");
		swdevt[0].sw_dev = makedev(trfs_no, 1);
		swdevt[0].sw_nblks = rdswapsize;
	}
#endif	TRFS

	/*
	 * Good {morning,afternoon,evening,night}.
	 */
	printf("%sreal      memory = %mM\n", version, 
		ctob(physmem + detachedmem));
	if (detachedmem)
		printf("detached  memory = %mM at0x%8x\n", ctob(detachedmem),
			ctob(physmem));

	/*
	 * Allocate space for system data structures. The first available real 
	 * memory address is in "firstaddr". The first available kernel virtual
	 * address is in "v". As pages of kernel virtual memory are allocated,
	 * "v" is incremented. As pages of memory are allocated and cleared,
	 * "firstaddr" is incremented.  
	 */
#define	valloc(name, type, num) 					\
	    dbg_addkvsymbol(":name", v);				\
	    (name) = (type *)(v); (v) = (caddr_t)((name)+(num))
#define	valloclim(name, type, num, lim) 				\
	    dbg_addkvsymbol(":name", v);				\
	    (name) = (type *)(v); (v) = (caddr_t)((lim) = ((name)+(num)))

	v = (caddr_t)(SYSV_BASE | ctob(firstaddr));
	valloclim(inode, struct inode, ninode, inodeNINODE);
	valloclim(file, struct file, nfile, fileNFILE);
	valloclim(proc, struct proc, nproc, procNPROC);
	valloclim(text, struct text, ntext, textNTEXT);
	valloc(cfree, struct cblock, nclist);
	valloc(callout, struct callout, ncallout);
	nswapmap = nproc * 2;
	valloc(swapmap, struct map, nswapmap);
	valloc(argmap, struct map, ARGMAPSIZE);
	valloc(kernelmap, struct map, USRPTSIZE);
	valloc(mbmap, struct map, nmbclusters/4);
	valloc(ncache, struct ncache, ncsize);
#ifdef	M68025
	valloc(qbmap, struct map, btop(0x800000));
#endif	M68025
#ifdef	QUOTA
#ifndef	is68k
	valloclim(quota, struct quota, nquota, quotaNQUOTA);
#endif	is68k
	valloclim(dquot, struct dquot, ndquot, dquotNDQUOT);
#endif	QUOTA
#ifdef	TRFS
	valloclim(Client, u_long, nproc, ClientNPROC);
#endif	TRFS
	

	/*
	 * Determine how many buffers to allocate.
	 * Use 10% of memory for the first 2 Meg, bufpcnt% [5,50] of the 
	 * remaining memory. Insure a minimum of 16 buffers.  We allocate half 
	 * as many swap buffer headers as file i/o buffers.
	 */
	if (bufpages == 0) {
		if (bufpcnt < 5)
			bufpcnt = 5;
		if (bufpcnt > 50)
			bufpcnt = 50;
#ifdef	TRFS
		/* If diskless, use 2% of 2 Meg or what we have. */
		if (diskless) {
			if (physmem >= btoc(2*1024*1024))
				bufpages = btoc(2*1024*1024)/(100/2)/CLSIZE;
			else
				bufpages = physmem/(100/2)/CLSIZE;
		} else
#endif	TRFS
		if (physmem < btoc(2*1024*1024))
			bufpages = physmem/(100/10)/CLSIZE;
		else {
			bufpages = btoc(2*1024*1024)/(100/10)/CLSIZE;
			bufpages += (physmem-btoc(2*1024*1024))/(100/bufpcnt)/CLSIZE;
		}
#ifdef	QBUS
#ifdef	TRFS
		if (!diskless)
#endif	TRFS
		bufpages -= btoc(NBUF18 * MAXBSIZE);
#endif	QBUS
	}
	if (nbuf == 0) {
		nbuf = (bufpages * CLBYTES) / AVGBSIZE;
		if (nbuf < 20)
			nbuf = 20;
	}
	if (nswbuf == 0) {
		nswbuf = (nbuf / 2) &~ 1;	/* force even */
		if (nswbuf > 256)
			nswbuf = 256;		/* sanity */
	}
	if (nswbuf > 32)
		nswbuf = 32;		/* temporary KLUDGE -- see swap() */

	valloc(swbuf, struct buf, nswbuf);

	/*
	 * Now the amount of virtual memory remaining for buffers can be 
	 * calculated, estimating needs for the cmap.
	 */
	ncmap = (maxmem*NBPG - ((int)v &~ SYSV_BASE)) /
		(CLBYTES + sizeof(struct cmap)) + 2;
	maxbufs = ((SYSPTSIZE * NBPG) -
	    ((int)(v + ncmap * sizeof(struct cmap)) - SYSV_BASE)) /
		(MAXBSIZE + sizeof(struct buf));
	if (maxbufs < 16)
		panic("sys pt too small");
	if (nbuf > maxbufs) {
	    printf("***  WARNING:  SYSPTSIZE limits buffers: %d to %d ***\n",
		nbuf, maxbufs);
	    nbuf = maxbufs;
	}
	if (bufpages > nbuf * (MAXBSIZE / CLBYTES)) {
	    printf("***  WARNING:  SYSPTSIZE limits bufpages: %d to %d ***\n",
		bufpages, nbuf * (MAXBSIZE / CLBYTES));
	    bufpages = nbuf * (MAXBSIZE / CLBYTES);
	}
#ifdef	QBUS
	valloc(buffermap18, struct map, NBUF18+1);
	valloc(buf18, struct buf, NBUF18);
	/* buffers18 is allocated in the text area locore.10.s */
#endif	QBUS
	valloc(buffermap, struct map, nbuf+1);
	valloc(buf, struct buf, nbuf);
	valloc(buffers, char, bufpages * CLBYTES);

	/*
	 * Allocate space for core map.
	 * Allow space for all of phsical memory minus the amount 
	 * dedicated to the system. The amount of physical memory
	 * dedicated to the system is the total virtual memory of
	 * the system thus far, plus core map, buffer pages,
	 * and buffer headers not yet allocated.
	 * Add 2: 1 because the 0th entry is unused, 1 for rounding.
	 */
	ncmap = (maxmem*NBPG - ((int)v &~ SYSV_BASE)) /
		(CLBYTES + sizeof(struct cmap)) + 2;
	valloclim(cmap, struct cmap, ncmap, ecmap);
	if (((int)v & ~SYSV_BASE) > SYSPTSIZE*NBPG) {
		printf("v %x, max %x\n", (int)v & ~SYSV_BASE, SYSPTSIZE*NBPG);
		panic("SYSPTSIZE too small");
	}

	/*
	 * Clear space allocated thus far, and make r/w entries for the space 
	 * in the kernel map.
	 */
	unixsize = btoc((int)v &~ SYSV_BASE);
	while (firstaddr < unixsize) {
		*(int *)(&Sysmap[firstaddr]) = PG_V|PG_KW|PG_CACHE|firstaddr;
		clearseg((u_int)firstaddr);
		firstaddr++;
	}

	if (firstaddr >= physmem - 8*UPAGES)
		panic("no memory");
	newptes(&Sysmap[fa], fa, firstaddr - fa);

	/* Initialize callouts */
	callfree = callout;
	for (i = 1; i < ncallout; i++)
		callout[i-1].c_next = &callout[i];

	/* Initialize memory allocator and swap and user page table maps.  */
	meminit(firstaddr, maxmem);
	maxmem = freemem;
	printf("available memory = %mM\n", ctob(maxmem));
	/*
	 * Allow upto 75 % of memory to be locked. This number should be tuned;
	 * it is user settable in param.c.
	 */
	if (lockablemem == 0) {
		lockablemem = (maxmem * 75) / 100;
		printf("max lockable mem = %mM\n", ctob(lockablemem));
	} else 
		printf("usr lockable mem = %mM\n", ctob(lockablemem));
	if (maxmem < 128)
		printf("***  WARNING:  Insufficient memory for this configuration  ***\n\n");
#ifdef	QBUS
	printf("using %d buffers containing %mM of memory\n", nbuf + NBUF18,
		(bufpages * CLBYTES) + (NBUF18 * MAXBSIZE));
#else	QBUS
	printf("using %d buffers containing %mM of memory\n", nbuf,
		(bufpages * CLBYTES));
#endif	QBUS
	rminit(buffermap, bufpages * CLBYTES, (long)buffers,
	    "buffers", nbuf+1);
#ifdef	QBUS
	rminit(buffermap18, NBUF18 * MAXBSIZE, (long)buffers18,
	    "18bitbuffers", nbuf+1);
#endif	QBUS
	rminit(kernelmap, (long)USRPTSIZE-1, (long)1,
	    "usrpt", USRPTSIZE);
	rminit(mbmap, (long)((nmbclusters - 1) * CLSIZE), (long)CLSIZE,
	    "mbclusters", nmbclusters/4);

	qbinit();		/* initialize bus map */
	kmem_init();		/* initialize kernel memory allocator */
	configure();		/* Configure the system.  */
}

#ifdef	PGINPROF
/*
 * Return the difference (in microseconds)
 * between the  current time and a previous
 * time as represented  by the arguments.
 */
vmtime(otime, olbolt, oicr)
	int otime, olbolt, oicr;
{
	return(((time.tv_sec-otime)*60 + lbolt-olbolt)*16667 + (0-oicr));
}
#endif	PGINPROF

chkaout(machtype)
{
	return(0);		/* KLUDGE FOR NOW */
}

intsvc()
{
	return(int_svc);
}

/*
 * Clear registers on exec
 */
setregs(entry)
	u_long entry;
{
	register int i;
	register struct proc *p = u.u_procp;
#ifdef vax
#define	NIREG 12
	static int ireg[NIREG] =
	{R0,R1,R2,R3,R4,R5,R6,R7,R8,R9,R10,R11};
#endif vax
#ifdef is68k
#define	NIREG 15
	static int ireg[NIREG] =
	{R0,R1,R2,R3,R4,R5,R6,R7,R8,R9,R10,R11,R12,R13,R14};
#endif is68k
	/* should pass args to init on the stack */
	for (i = 0 ; i < NIREG ; i++)
		u.u_ar0[ireg[i]] = 0;
		u.u_ar0[PC] = entry + 2;

 	/*
 	 * Clear any external and internal fpp state. 
	/* FUTURE: If this process was the last one to load its external fpp 
	 * state, erase that fact also.
 	 */
#ifdef	M68020
	bzero(u.u_68881_state, sizeof (u.u_68881_state));
	bzero(u.u_68881_regs, sizeof (u.u_68881_regs));
#endif	M68020
	bzero(u.u_skyregs, sizeof (u.u_68881_regs));
}

/*
 * Simulate vax sigcontext in <signal.h>, but with 680[12]0 stack frame format. 
 * Note that pc and psl are exchanged (they are in vax order).
 */
struct sigctx {
	int		sc_onstack;		/* sigstack state to restore */
	int		sc_mask;		/* signal mask to restore */
	int		sc_sp;			/* user sp to restore */
	union xsf	sc_xsf;			/* extended exception frame */
};						/* with pc and psl exchanged */
#define	sc_pc	sc_xsf.xf0.xsf_psl		/* vax pc position */
#define	sc_psl	sc_xsf.xf0.xsf_pc		/* vax psl position */

/*
 * Args to sigcode, plus eventual arg to sigcleanup, pushed on interrupt stack.
 * sigcode copies the first 3 items to make args to user's handler.
 */
struct sigframe {
	int		sf_sig;			/* signal # */
	int		sf_code;		/* extra hdware code */
	struct sigctx	*sf_sctxp;		/* ptr to sigcontext */
	int		(*sf_handler)();	/* user's handler */
	struct sigctx	*sf_copy_sctxp;		/* arg for sigcleanup */
};

/*
 * Sendsig - Send an interrupt to a process: First sigcode (see locore.s) gets 
 * pushed on the current user stack, for lack of any better place to put it.  
 * Then a max size sigctx structure (an extended sigcontext structure from 
 * <signal.h>) gets pushed on the user stack, to be used by sigcleanup (below)
 * to return to the user state before the interrupt occurred.  After pushing
 * the sigctx structure, we potentially switch to the user's interrupt stack.  
 * We push a sigframe structure, providing the arguments to the signal handler.
 * When we return from here to the user, we will return to the stacked sigcode.
 * After the user's signal handler returns to the sigcode, it will trap to 
 * sigcleanup (below) to finish the job. There is a unique trap #code for each 
 * 680[12]0 stack format to clean up.
 */
sendsig(handler, sig, mask)
int		(*handler)();			/* user's signal handler */
register int	sig;				/* signal number */
int		mask;				/* mask restore */
{
	register caddr_t	sigp;		/* where sigcode goes */
	struct sigctx		sctx;		/* sigctx is built here */
	register struct sigctx	*sctxp;		/* where sigctx goes */
	struct sigframe		sframe;		/* sigframe is built here */
	register struct sigframe *sframep;	/* where sigframe goes */
	register int		*regs;		/* ptr to user's regs */
	u_short			*vec;		/* stack format vector ptr */
	register int		xsfsize;	/* size of xsf stack frame */
	register int		oonstack;	/* old onstack status */
	extern caddr_t		sigcode;	/* sigcode, in locore.s */
	extern int		szsigcode;	/* sizeof sigcode */


	regs = u.u_ar0;
	oonstack = u.u_onstack;
	if (regs[SP] >= USRSTACK)	/* out of range */
		goto bad;
	sigp = (char *)(regs[SP] - szsigcode); /* claim space for sigcode */
	sctxp = (struct sigctx *)sigp - 1; /* claim space for sigctx */

	if (!u.u_onstack && (u.u_sigonstack & sigmask(sig))) {
		sframep = (struct sigframe *)u.u_sigsp - 1;
		u.u_onstack = 1;
	} else
		sframep = (struct sigframe *)sctxp - 1;

	/*
	 * Must build signal handler context on stack to be returned to so that
	 * sigcleanup (trapped to from sigcode) will pop ps and pc off correct 
	 * stack.  The remainder of the signal state used in calling the handler
	 * must be placed on the stack on which the handler is to operate so 
	 * that the procedure entry code in sigcode will save the registers and
	 * such correctly.
	 */
	if (!oonstack && (u_int)sframep <= USRSTACK - ctob(u.u_ssize)) 
		(void) grow((u_int)sframep);
	if (!useracc((caddr_t)sframep, sizeof (struct sigframe), B_WRITE))
		goto bad;
	if (!u.u_onstack && (u_int)sctxp <= USRSTACK - ctob(u.u_ssize))
		(void) grow((u_int)sctxp);
	if (!useracc((caddr_t)sctxp, sizeof (struct sigctx), B_WRITE))
		goto bad;
	if (copyout(sigcode, sigp, (u_int)szsigcode))
		goto bad;
	sframe.sf_sig = sig;
	if (sig == SIGILL || sig == SIGFPE) {
		sframe.sf_code = u.u_code;
		u.u_code = 0;
	} else
		sframe.sf_code = 0;
	sframe.sf_sctxp = sctxp;
	sframe.sf_handler = handler;

	/*
	 * Duplicate the pointer to the sigctx structure. This one doesn't get 
	 * popped by the rtd, and is used by sigcleanup to reset the signal 
	 * state on inward return.
	 */
	sframe.sf_copy_sctxp = sctxp;

	/* put sigframe structure on user's interrupt stack */
	if (copyout((caddr_t)&sframe, (char *)sframep, (u_int)sizeof(sframe)))
		goto bad;

	/* 
	 * Compute extended exception stack frame size and its sigcode entry
	 */
	sctx.sc_onstack = oonstack;	/* sigctx goes on previous stack */
	sctx.sc_mask = mask;
	sctx.sc_sp = regs[SP];
	vec = (u_short *)&regs[PC + 1];	/* xsf format/vector */
	switch (*vec & (ESF_FMTMSK & ~ESF_SOFT)) {
	  case ESF_FMT0:		/* sigcode returns via trap #8 */
		xsfsize = XSF_ISIZE0; sigp += 0; break;
	  case ESF_FMT2:		/* sigcode returns via trap #6 */
		xsfsize = XSF_ISIZE2; sigp += 2; break;
	  case ESF_FMT8:		/* sigcode returns via trap #5 */
		xsfsize = XSF_ISIZE8; sigp += 4; break;
	  case ESF_FMT9:		/* sigcode returns via trap #4 */
		xsfsize = XSF_ISIZE9; sigp += 6; break;
	  case ESF_FMTA:		/* sigcode returns via trap #3 */
		xsfsize = XSF_ISIZEA; sigp += 8; break;
	  case ESF_FMTB:		/* sigcode returns via trap #2 */
		xsfsize = XSF_ISIZEB; sigp += 10; break;
	  default:
		panic("Sendsig: bad stack format");
	}

	/* copy appropriate amount of kernel exception stack to local buffer */
	bcopy((caddr_t)&regs[PS], (caddr_t)&sctx.sc_pc, xsfsize);
	sctx.sc_psl = regs[PS];		/* make VAX order pc/psl */
	sctx.sc_pc = regs[PC];		/* make VAX order pc/psl */

	/* copy local sigctx to previous user stack */
	if (copyout((char *)&sctx, (char *)sctxp, (u_int)sizeof(sctx)))
		goto bad;

	/* 
	 * If we have a long frame, mark it so locore will collapse it to a 
	 * short 4-word frame to enter user sigcode.
	 */
	if (xsfsize != XSF_ISIZE0)	/* tell locore to collapse stack */
		*vec |= ESF_SOFT;	/* use illegal stack format bit */
	regs[SP] = (int)sframep;
	regs[PC] = (int)sigp;
	return;

bad:	sendill();
}

sigreturn(){}				/* KLUDGE 4.3 */

/*
 * Routine to cleanup state after a longjmp or signal has been taken. This is 
 * entered via trap #{8,7,6,5,4,3,2} which generates a negative syscall 
 * {-2,-1,-3,-4,-5,-6,-7}, one code per 680[12]0 exception stack format. User 
 * stack top is ptr to sigctx placed by Sendsig. Reset signal mask and stack 
 * state from sigctx, then fake a vax rei.
 */
sigcleanup(code)
int	code;		/* negative syscall code */
{
	struct sigctx		sctx;		/* local sigcontext buffer */
	register struct sigctx	*sctxp;		/* addr of user sigcontext */
	register struct proc	*p = u.u_procp;	/* current process */
	register u_int		sp;
	register u_int		ulen;		/* sizeof sigcontext struct */
	register u_short	fmt;		/* xsf stack format */
	register int		xsfsize;	/* size of xsf stack frame */

	if (code == -1)			/* longjmp cleanup */
		ulen = 5*4;		/* sizeof vax sigcontext cleanup */
	else
		ulen = sizeof(sctx);	/* sizeof 680[12]0 max sigcontext */

	sctxp = (struct sigctx *)fuword((caddr_t)u.u_ar0[SP]);
	if ((int)sctxp == -1)
		goto bad;
	if (!useracc((caddr_t)sctxp, ulen, B_WRITE))
		goto bad;
	/* get user's sigctx structure */
	if (copyin((caddr_t)sctxp, (caddr_t)&sctx, ulen))
		goto bad;
	u.u_onstack = sctx.sc_onstack & 01;
	p->p_sigmask = 
		sctx.sc_mask &~ (sigmask(SIGKILL)|sigmask(SIGCONT)|sigmask(SIGSTOP));
	sp = sctx.sc_sp;

	/* compute size of xsf stack frame */
	fmt = sctx.sc_xsf.xf0.xsf_vec & (ESF_FMTMSK & ~ESF_SOFT);
	xsfsize = -1;
	switch(code) {
	  case -1:		/* trap #7 longjmp cleanup */
		sp += 8;	/* pop pc and psl in fake sigcontext */
		xsfsize = 0;	/* don't copy user sigcontext */
		break;
	  case -2:		/* trap #8 xsf format 0 signal cleanup */
		if (fmt == ESF_FMT0)
			xsfsize = XSF_ISIZE0;
		break;
	  case -3:		/* trap #6 xsf format 2 signal cleanup */
		if (fmt == ESF_FMT2)
			xsfsize = XSF_ISIZE2;
		break;
	  case -4:		/* trap #5 xsf format 8 signal cleanup */
		if (fmt == ESF_FMT8)
			xsfsize = XSF_ISIZE8;
		break;
	  case -5:		/* trap #4 xsf format 9 signal cleanup */
		if (fmt == ESF_FMT9)
			xsfsize = XSF_ISIZE9;
		break;
	  case -6:		/* trap #3 xsf format A signal cleanup */
		if (fmt == ESF_FMTA)
			xsfsize = XSF_ISIZEA;
		break;
	  case -7:		/* trap #2 xsf format B signal cleanup */
		if (fmt == ESF_FMTB)
			xsfsize = XSF_ISIZEB;
		break;
	  default:
		goto bad;
	}
	if (xsfsize == -1)	/* user changed the stack format */
		goto bad;
	if (xsfsize > 0)	/* user's sigcontext is in vax order */
		bcopy((char *)&sctx.sc_pc, (char *)&u.u_ar0[PS], xsfsize);

	/* 
	 * now fake a vax rei, then pop the sigcode off user stack.
	 */
	u.u_ar0[PC] = sctx.sc_pc;	/* get pc from VAX order sigcontext */
	u.u_ar0[PS] = sctx.sc_psl;	/* get psl from VAX order sigcontext */
	u.u_ar0[PS] |= PSL_USERSET;	/* ensure return to user mode */
	u.u_ar0[PS] &= ~PSL_USERCLR;
	u.u_ar0[SP] = sp;
	return;

bad:	sendill();
}

/* proc trashed its stack, zap it */
sendill()
{
	register int sig;

	u.u_signal[SIGILL] = SIG_DFL;
	sig = sigmask(SIGILL);
	u.u_procp->p_sigignore &= ~sig;
	u.u_procp->p_sigcatch &= ~sig;
	u.u_procp->p_sigmask &= ~sig;
	psignal(u.u_procp, SIGILL);
}

#ifdef	M68020
static int tout_cpu = 1;
static int cpu_tout()
{
	tout_cpu = 0;
}
#endif	M68020

prcpuspeed()
{
#ifdef	M68020
	register u_int i, j, k;
#define	DIVIDER	412

	timeout(cpu_tout, (caddr_t)0, 4*hz);
	spl0();
	for(i = 0; tout_cpu ; i++)
		DELAY(100);
	spl7();
	j = i/DIVIDER;
	k = ((i - (j*DIVIDER)) * 100) / DIVIDER;
/*	printf("TUNE SPEED: %d.%dMHz == %d\n", j, k/10, i); /**/
	if (j < 16) {
		printf(" <16");		cpuspeed = 4;
	} else if (j == 16 && k/10 < 3) {
		printf("16");		cpuspeed = 6;
	} else if (j < 17) {
		printf("16.67");	cpuspeed = 8;
	} else if (j < 21) {
		printf("20.0");		cpuspeed = 10;
	} else if (j < 26) {
		printf("25.0");		cpuspeed = 14;
	} else {
		printf(" >25.0");	cpuspeed = 20;
	}
	printf("MHz MC68020 CPU");

	if (have68881())
		printf(" with MC68881 Floating-Point Coprocessor");
	printf("\n");
#else	M68020
	/* cpuspeed is set in sioinit */
	switch (*BSR & BSR_CPUSPEED) {
#ifdef	BSR_CPUSPEED8
	  case BSR_CPUSPEED8:	printf("8"); break;
#endif	BSR_CPUSPEED8
#ifdef	BSR_CPUSPEED10
	  case BSR_CPUSPEED10:	printf("10"); break;
#endif	BSR_CPUSPEED10
#ifdef	BSR_CPUSPEED11
	  case BSR_CPUSPEED11:	printf("11.1"); break;
#endif	BSR_CPUSPEED11
#ifdef	BSR_CPUSPEED12
	  case BSR_CPUSPEED12:	printf("12"); break;
#endif	BSR_CPUSPEED12
	}
	printf("MHz MC68010 CPU\n");
#endif	M68020
}

int want_parity = 1;
memenable()
{
#ifdef	QBUS
	/* older QBUS CPU cards do not correctly support parity */
#else	QBUS
	if (want_parity) {
		printf("Parity Enabled\n");
		parityon();
	} else {
		printf("Parity NOT Enabled\n");
		parityoff();
	}
#endif	QBUS
}

int	waittime = -1;

boot(paniced, arghowto)
	int paniced, arghowto;
{
	register struct buf *bp;
	int iter, nbusy0, nbusy1;

#if	DEBUGGER
	if (paniced != RB_BOOT)
		trap15();
#endif	DEBUGGER
/*	bufertrace();	/* */
/*	sleeptrace();	/* */
/*	stacktrace();	/* */
	(void) spl0();
	howto = arghowto;
	devtype = rootdev;
	if ((howto&RB_NOSYNC)==0 && waittime < 0 && bfreelist[0].b_forw) {
		waittime = 0;
		/*
		 * Release vnodes held by texts before update.
		 */
		xumount(NODEV);
		update();
		if (diskless)
			printf("syncing server... ");
		else 
			printf("syncing disks... ");
		nbusy0 = 100000;
		for (iter = 0; iter < 20; iter++) {
			nbusy1 = 0;
			for (bp = &buf[nbuf]; --bp >= buf; )
				if ((bp->b_flags & (B_BUSY|B_INVAL)) == B_BUSY)
					nbusy1++;
			if (nbusy1 == 0)
				break;
			if (nbusy1 < nbusy0) {
				printf("%d ", nbusy1);
				nbusy0 = nbusy1;
				iter = 0;
			}
			DELAY(4000 * iter);
		}
		DELAY(4000);
		printf("...done\n");
		/*
		 * If we've been adjusting the clock, the todr
		 * will be out of synch; adjust it now.
		 */
		resettodr();
		DELAY(4000);
	}
#ifdef	TRFS
	/* Tell others we are gone... */
	TrfsShutdown();
#endif	TRFS
	ifqbreset(0);			/* reset network interfaces */
	DELAY(8000);
	spl7();
	if (howto&RB_HALT) {
		printf("halting (in tight loop); hit RESET\n\n");
		for (;;)
			;
	} else if (paniced == RB_PANIC)
		doadump();
	DELAY(400000);		/* let graphics screen finish scroll! */
	_reboot();
	/*NOTREACHED*/
}

/*
 * Return the best possible estimate of the time in the timeval
 * to which tvp points.  We do this by reading the interval count
 * register to determine the time remaining to the next clock tick.
 * We must compensate for wraparound which is not yet reflected in the time
 * (which happens when the ICR hits 0 and wraps after the splhigh(),
 * but before the mfpr(ICR)).  Also check that this time is no less than
 * any previously-reported time, which could happen around the time
 * of a clock adjustment.  Just for fun, we guarantee that the time
 * will be greater than the value obtained by a previous call.
 */
microtime(tvp)
	register struct timeval *tvp;
{
#ifdef	vax
	int s = splhigh();
	static struct timeval lasttime;
	register long t;

	*tvp = time;
	t =  mfpr(ICR);
	if (t < -tick / 2 && (mfpr(ICCS) & ICCS_INT))
		t += tick;
	tvp->tv_usec += tick + t;
	if (tvp->tv_usec > 1000000) {
		tvp->tv_sec++;
		tvp->tv_usec -= 1000000;
	}
	if (tvp->tv_sec == lasttime.tv_sec &&
	    tvp->tv_usec <= lasttime.tv_usec &&
	    (tvp->tv_usec = lasttime.tv_usec + 1) > 1000000) {
		tvp->tv_sec++;
		tvp->tv_usec -= 1000000;
	}
	lasttime = *tvp;
	splx(s);
#else	vax
	uniqtime(tvp);
#endif	vax
}

uniqtime(tv)					/* NFS: */
	register struct timeval *tv;
{
	static struct timeval lasttime;
	static int uniq;

	while (lasttime.tv_usec != time.tv_usec || 
	    lasttime.tv_sec != time.tv_sec) {
		lasttime = time;
		uniq = 0;
	}
	*tv = lasttime;
	tv->tv_usec += uniq++;
}

physstrat(bp, strat, prio, locked)
	register struct buf *bp;
	int (*strat)(), prio;
{
	register struct buf *bbp;

	/* pageout daemon doesn't wait for pushed pages */
	if (bp->b_flags & B_DIRTY)
		(*strat)(bp);
	else {
	    if (
#ifdef	TRFS
	        u.u_tclient  ||
#endif	TRFS
		(qbaddrcontig(bp) != bp->b_bcount)
#ifdef	QBUS
		|| (BQUALIFY(bp->b_dev)&B_18BIT)
#endif	QBUS
		) {
		if (locked) {
		    vsunlock(bp->b_un.b_addr, bp->b_bcount, bp->b_flags&B_READ);
		    locked = 0;
		}
		bbp = (struct buf *)getqeblk(bp->b_bcount, BQUALIFY(bp->b_dev));
		bbp->b_dev = bp->b_dev;
		bbp->b_blkno = bp->b_blkno;
		bbp->b_flags |= (bp->b_flags & (B_READ|B_WRITE));
		if ((bp->b_flags & B_READ) == B_WRITE)
			copyin(bp->b_un.b_addr, bbp->b_un.b_addr, bp->b_bcount);
		(*strat)(bbp);
		biowait(bbp);
		if ((bp->b_flags & B_READ) && (bp->b_bcount - bbp->b_resid) > 0)
			copyout(bbp->b_un.b_addr, bp->b_un.b_addr, 
				bp->b_bcount-bbp->b_resid);
		bp->b_resid = bbp->b_resid;
		bp->b_flags |= (bbp->b_flags & B_ERROR)|B_DONE;
		bp->b_error = bbp->b_error;
		bbp->b_dev = NODEV;
		bfree(bbp);
		brelse(bbp);
	    } else {
		(*strat)(bp);
		biowait(bp);
	    }
	}
	return locked;
}

stacktrace (arg0, arg1)
	int arg0, arg1;
{
#ifdef STACKTRACE
	register struct frame *fp = ((struct frame *)&arg1) - 1;
	register struct frame *nextfp;
	register i = 0, j;
	int s;

	s = spl6();
	if ((caddr_t)fp < (caddr_t)&u  ||  
	    ((caddr_t)fp + sizeof(struct frame)) > (caddr_t)&u + UPAGES*NBPG) {
		printf("stacktrace: illegal initial fp %x\n", fp);
		splx(s);
		return;
	}
	printf("Stacktrace:	PC		FP       ARGS\n");
	for (nextfp = (struct frame *)fp->fr_savfp;  ((int)nextfp & 1) == 0  &&
	     nextfp > fp  &&  (caddr_t)nextfp > (caddr_t)&u && 
	     ((caddr_t)nextfp + sizeof(struct frame)) < (caddr_t)&u + UPAGES*NBPG;
	     nextfp = (struct frame *)fp->fr_savfp) {
		fp = nextfp;
		printf("%a 	%8x ", fp->fr_savpc, fp->fr_savfp);
		for (j = 0 ; j < stacktrace_args ; j++)
			printf("%c%x", j?',':'(', fp->fr_arg[j]);
		printf(")\n");
		if (stacktrace_depth && ++i > stacktrace_depth) {
			printf("    ...\n");
			break;
		}
	}
	splx(s);
#endif STACKTRACE
}

bufertrace()
{
#ifdef BUFFERTRACE
	register struct buf *dp, *bp;
	char *bqname[BQUEUES];
	int i, j;
	int s;

	s = spl6();
	bqname[BQ_LOCKED] = "LOCKED";
	bqname[BQ_LRU] = "LRU";
	bqname[BQ_AGE] = "AGE";
	bqname[BQ_EMPTY] = "EMPTY";
	for (i=0,j=0 ; i < BQUEUES ; i++) {
		dp = &bfreelist[i];
		printf("FREE QUEUE %s %x :\n	",bqname[i],dp);
		for (bp = dp->av_forw ; bp != dp ; bp = bp->av_forw) {
#ifdef	QBUS
			if (bp->b_flags & B_18BIT)
				printf("*");
#endif	QBUS
			printf("(%x %b %x) ",bp, bp->b_flags, B_FLAGS_BITS, bp->b_bufsize);
			if ((++j)%2 == 0)
				printf("\n	");
		}
		printf("\n");
	}
	for (i=0 ; i < BUFHSZ ; i++) {
		dp = (struct buf*) &bufhash[i];
		if (dp->b_forw == dp || dp->b_forw == 0)
			continue;
		j = 0;
		printf("CACHE HASH %d %x :\n	",i,dp);
		for (bp = dp->b_forw ; bp != dp ; bp = bp->b_forw) {
#ifdef	QBUS
			if (bp->b_flags & B_18BIT)
				printf("*");
#endif	QBUS
			printf("(%x %b %x) ",bp, bp->b_flags, B_FLAGS_BITS, bp->b_bufsize);
			if ((++j)%2 == 0)
				printf("\n	");
		}
		printf("\n");
	}
	splx(s);
#endif BUFFERTRACE
}

#define	ARGBUF		((char *)0x700)
#define	ARGBUFSIZE	(0x100 - 0x10)
char *
strarg(p)
	register char *p;
{
	register char *q = ARGBUF;
	register int len = strlen(p);
	register int nleft = ARGBUFSIZE - len - 2;

	q[-1] = 0;
	while (--nleft >= 0) {
		switch (q[-1]) {
		  case '\0': case ' ': case '\t': case '\n': case '\r':
			break;
		  default:
			q++;
			continue;
		}
		if (strncmp(p, q, len) == 0  &&  q[len] == '=') {
			q = p = &q[len + 1];
			while (--nleft >= 0)
				switch (*p++) {
				  case '\0': case ' ': case '\t': case '\n':
				  case '\r':
					*--p = '\0';
					return q;
				}
			*--p = '\0';
			return q;
		}
		q++;
	}
	return (char *)0;
}

/*
 * Given a string atob() will return a number in *iptr.  This routine
 * is different from atoi() in the following ways.
 * 1) It will return 1 if there was some sort of conversion error.
 * 2) If the string starts with 0x the base is set to 16.  If the string
 *    starts with just 0 it will be base 8 else base 10.
 */
atob (buf, iptr)
	char *buf;
	int *iptr;
{
	int c, base, num;

	*iptr = 0;
	num = 0;
	if (buf == NULL)
	  return (1);
	if (*buf == '0') {
		if (*(buf + 1) == 'x') {
			base = 16;
			buf++;
		}
		else
		  base = 8;
		buf++;
	}
	else
	  base = 10;

	while (*buf != '\0') {
		c = *buf;
		if (c >= 'A' && c <= 'F')
		  c = c - 'A' + 'a'; /* convert to lower */
		if (c >= 'a' && c <= 'f')
		  num = num * base + c - 'a' + 10;
		else if (c >= '0' && c <= '9')
		  num = num * base + c - '0';
		else
		  return (1);
		buf++;
	}

	*iptr = num;
	return (0);
}
