/*	dlreg.h	6.1	83/07/29	*/

struct dldevice
{
	short dl_rcsr;		/* reciever control and status register */
	short dl_rbuf;		/* reciever data register */
	short dl_xcsr;		/* transmiter control and status register */
	short dl_xbuf;		/* transmiter data register */
};

/* 
 * Definitions for RCSR
 */
# define DL_RCSR_RE		0x0001	/* W  Reader Enable */
# define DL_RCSR_RCVIE		0x0040	/* RW Receiver Interrupt Enable	*/
# define DL_RCSR_RCVDONE	0x0080	/* R  Receiver Done */

/* 
 * Definitions for RBUF
 */
# define DL_RBUF_ANYERR		0x8000	/* R  Any error */
# define DL_RBUF_OVRNERR	0x4000	/* R  Overrun error */
# define DL_RBUF_FRERR		0x2000	/* R  Framing Error */
# define DL_RBUF_PERR		0x1000	/* R  Parity Error */
# define DL_RBUF_DMASK		0x00FF	/*    Data field mask */

/* 
 * Definitions for XCSR
 */
# define DL_XCSR_XBRK		0x0001	/* RW Transmit Break */
# define DL_XCSR_XIE		0x0040	/* R  Transmit Interrupt Enable */
# define DL_XCSR_TRDY		0x0080	/* R  Transmiter ready */
